import{S as hc,i as gc,s as uc,e as a,k as c,w as b,t as n,M as _c,c as s,d as t,m as p,a as i,x as $,h as r,b as l,N as vc,G as e,g as m,y as B,q as w,o as y,B as C,v as bc,L as Pn}from"../../chunks/vendor-hf-doc-builder.js";import{T as mc}from"../../chunks/Tip-hf-doc-builder.js";import{D as M}from"../../chunks/Docstring-hf-doc-builder.js";import{C as En}from"../../chunks/CodeBlock-hf-doc-builder.js";import{I as Z}from"../../chunks/IconCopyLink-hf-doc-builder.js";import{E as kn}from"../../chunks/ExampleCodeBlock-hf-doc-builder.js";function $c(F){let h,P,_,g,v;return g=new En({props:{code:`from transformers import (
    Blip2VisionConfig,
    Blip2QFormerConfig,
    OPTConfig,
    Blip2Config,
    Blip2ForConditionalGeneration,
)

# Initializing a Blip2Config with Salesforce/blip2-opt-2.7b style configuration
configuration = Blip2Config()

# Initializing a Blip2ForConditionalGeneration (with random weights) from the Salesforce/blip2-opt-2.7b style configuration
model = Blip2ForConditionalGeneration(configuration)

# Accessing the model configuration
configuration = model.config

# We can also initialize a Blip2Config from a Blip2VisionConfig, Blip2QFormerConfig and any PretrainedConfig

# Initializing BLIP-2 vision, BLIP-2 Q-Former and language model configurations
vision_config = Blip2VisionConfig()
qformer_config = Blip2QFormerConfig()
text_config = OPTConfig()

config = Blip2Config.from_text_vision_configs(vision_config, qformer_config, text_config)`,highlighted:`<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">from</span> transformers <span class="hljs-keyword">import</span> (
<span class="hljs-meta">... </span>    Blip2VisionConfig,
<span class="hljs-meta">... </span>    Blip2QFormerConfig,
<span class="hljs-meta">... </span>    OPTConfig,
<span class="hljs-meta">... </span>    Blip2Config,
<span class="hljs-meta">... </span>    Blip2ForConditionalGeneration,
<span class="hljs-meta">... </span>)

<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-comment"># Initializing a Blip2Config with Salesforce/blip2-opt-2.7b style configuration</span>
<span class="hljs-meta">&gt;&gt;&gt; </span>configuration = Blip2Config()

<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-comment"># Initializing a Blip2ForConditionalGeneration (with random weights) from the Salesforce/blip2-opt-2.7b style configuration</span>
<span class="hljs-meta">&gt;&gt;&gt; </span>model = Blip2ForConditionalGeneration(configuration)

<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-comment"># Accessing the model configuration</span>
<span class="hljs-meta">&gt;&gt;&gt; </span>configuration = model.config

<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-comment"># We can also initialize a Blip2Config from a Blip2VisionConfig, Blip2QFormerConfig and any PretrainedConfig</span>

<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-comment"># Initializing BLIP-2 vision, BLIP-2 Q-Former and language model configurations</span>
<span class="hljs-meta">&gt;&gt;&gt; </span>vision_config = Blip2VisionConfig()
<span class="hljs-meta">&gt;&gt;&gt; </span>qformer_config = Blip2QFormerConfig()
<span class="hljs-meta">&gt;&gt;&gt; </span>text_config = OPTConfig()

<span class="hljs-meta">&gt;&gt;&gt; </span>config = Blip2Config.from_text_vision_configs(vision_config, qformer_config, text_config)`}}),{c(){h=a("p"),P=n("Example:"),_=c(),b(g.$$.fragment)},l(d){h=s(d,"P",{});var u=i(h);P=r(u,"Example:"),u.forEach(t),_=p(d),$(g.$$.fragment,d)},m(d,u){m(d,h,u),e(h,P),m(d,_,u),B(g,d,u),v=!0},p:Pn,i(d){v||(w(g.$$.fragment,d),v=!0)},o(d){y(g.$$.fragment,d),v=!1},d(d){d&&t(h),d&&t(_),C(g,d)}}}function Bc(F){let h,P,_,g,v;return g=new En({props:{code:`from transformers import Blip2VisionConfig, Blip2VisionModel

# Initializing a Blip2VisionConfig with Salesforce/blip2-opt-2.7b style configuration
configuration = Blip2VisionConfig()

# Initializing a Blip2VisionModel (with random weights) from the Salesforce/blip2-opt-2.7b style configuration
model = Blip2VisionModel(configuration)

# Accessing the model configuration
configuration = model.config`,highlighted:`<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">from</span> transformers <span class="hljs-keyword">import</span> Blip2VisionConfig, Blip2VisionModel

<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-comment"># Initializing a Blip2VisionConfig with Salesforce/blip2-opt-2.7b style configuration</span>
<span class="hljs-meta">&gt;&gt;&gt; </span>configuration = Blip2VisionConfig()

<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-comment"># Initializing a Blip2VisionModel (with random weights) from the Salesforce/blip2-opt-2.7b style configuration</span>
<span class="hljs-meta">&gt;&gt;&gt; </span>model = Blip2VisionModel(configuration)

<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-comment"># Accessing the model configuration</span>
<span class="hljs-meta">&gt;&gt;&gt; </span>configuration = model.config`}}),{c(){h=a("p"),P=n("Example:"),_=c(),b(g.$$.fragment)},l(d){h=s(d,"P",{});var u=i(h);P=r(u,"Example:"),u.forEach(t),_=p(d),$(g.$$.fragment,d)},m(d,u){m(d,h,u),e(h,P),m(d,_,u),B(g,d,u),v=!0},p:Pn,i(d){v||(w(g.$$.fragment,d),v=!0)},o(d){y(g.$$.fragment,d),v=!1},d(d){d&&t(h),d&&t(_),C(g,d)}}}function wc(F){let h,P,_,g,v;return g=new En({props:{code:`from transformers import Blip2QFormerConfig, Blip2QFormerModel

# Initializing a BLIP-2 Salesforce/blip2-opt-2.7b style configuration
configuration = Blip2QFormerConfig()

# Initializing a model (with random weights) from the Salesforce/blip2-opt-2.7b style configuration
model = Blip2QFormerModel(configuration)
# Accessing the model configuration
configuration = model.config`,highlighted:`<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">from</span> transformers <span class="hljs-keyword">import</span> Blip2QFormerConfig, Blip2QFormerModel

<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-comment"># Initializing a BLIP-2 Salesforce/blip2-opt-2.7b style configuration</span>
<span class="hljs-meta">&gt;&gt;&gt; </span>configuration = Blip2QFormerConfig()

<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-comment"># Initializing a model (with random weights) from the Salesforce/blip2-opt-2.7b style configuration</span>
<span class="hljs-meta">&gt;&gt;&gt; </span>model = Blip2QFormerModel(configuration)
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-comment"># Accessing the model configuration</span>
<span class="hljs-meta">&gt;&gt;&gt; </span>configuration = model.config`}}),{c(){h=a("p"),P=n("Examples:"),_=c(),b(g.$$.fragment)},l(d){h=s(d,"P",{});var u=i(h);P=r(u,"Examples:"),u.forEach(t),_=p(d),$(g.$$.fragment,d)},m(d,u){m(d,h,u),e(h,P),m(d,_,u),B(g,d,u),v=!0},p:Pn,i(d){v||(w(g.$$.fragment,d),v=!0)},o(d){y(g.$$.fragment,d),v=!1},d(d){d&&t(h),d&&t(_),C(g,d)}}}function yc(F){let h,P,_,g,v;return{c(){h=a("p"),P=n("Although the recipe for forward pass needs to be defined within this function, one should call the "),_=a("code"),g=n("Module"),v=n(`
instance afterwards instead of this since the former takes care of running the pre and post processing steps while
the latter silently ignores them.`)},l(d){h=s(d,"P",{});var u=i(h);P=r(u,"Although the recipe for forward pass needs to be defined within this function, one should call the "),_=s(u,"CODE",{});var D=i(_);g=r(D,"Module"),D.forEach(t),v=r(u,`
instance afterwards instead of this since the former takes care of running the pre and post processing steps while
the latter silently ignores them.`),u.forEach(t)},m(d,u){m(d,h,u),e(h,P),e(h,_),e(_,g),e(h,v)},d(d){d&&t(h)}}}function Cc(F){let h,P,_,g,v;return{c(){h=a("p"),P=n("Although the recipe for forward pass needs to be defined within this function, one should call the "),_=a("code"),g=n("Module"),v=n(`
instance afterwards instead of this since the former takes care of running the pre and post processing steps while
the latter silently ignores them.`)},l(d){h=s(d,"P",{});var u=i(h);P=r(u,"Although the recipe for forward pass needs to be defined within this function, one should call the "),_=s(u,"CODE",{});var D=i(_);g=r(D,"Module"),D.forEach(t),v=r(u,`
instance afterwards instead of this since the former takes care of running the pre and post processing steps while
the latter silently ignores them.`),u.forEach(t)},m(d,u){m(d,h,u),e(h,P),e(h,_),e(_,g),e(h,v)},d(d){d&&t(h)}}}function kc(F){let h,P,_,g,v;return g=new En({props:{code:`from PIL import Image
import requests
from transformers import Blip2Processor, Blip2ForConditionalGeneration
import torch

device = "cuda" if torch.cuda.is_available() else "cpu"

processor = Blip2Processor.from_pretrained("Salesforce/blip2-opt-2.7b")
model = Blip2ForConditionalGeneration.from_pretrained(
    "Salesforce/blip2-opt-2.7b", torch_dtype=torch.float16
)
model.to(device)
url = "http://images.cocodataset.org/val2017/000000039769.jpg"
image = Image.open(requests.get(url, stream=True).raw)

inputs = processor(images=image, return_tensors="pt").to(device, torch.float16)

generated_ids = model.generate(**inputs)
generated_text = processor.batch_decode(generated_ids, skip_special_tokens=True)[0].strip()
print(generated_text)`,highlighted:`<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">from</span> PIL <span class="hljs-keyword">import</span> Image
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">import</span> requests
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">from</span> transformers <span class="hljs-keyword">import</span> Blip2Processor, Blip2ForConditionalGeneration
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">import</span> torch

<span class="hljs-meta">&gt;&gt;&gt; </span>device = <span class="hljs-string">&quot;cuda&quot;</span> <span class="hljs-keyword">if</span> torch.cuda.is_available() <span class="hljs-keyword">else</span> <span class="hljs-string">&quot;cpu&quot;</span>

<span class="hljs-meta">&gt;&gt;&gt; </span>processor = Blip2Processor.from_pretrained(<span class="hljs-string">&quot;Salesforce/blip2-opt-2.7b&quot;</span>)
<span class="hljs-meta">&gt;&gt;&gt; </span>model = Blip2ForConditionalGeneration.from_pretrained(
<span class="hljs-meta">... </span>    <span class="hljs-string">&quot;Salesforce/blip2-opt-2.7b&quot;</span>, torch_dtype=torch.float16
<span class="hljs-meta">... </span>)
<span class="hljs-meta">&gt;&gt;&gt; </span>model.to(device)
<span class="hljs-meta">&gt;&gt;&gt; </span>url = <span class="hljs-string">&quot;http://images.cocodataset.org/val2017/000000039769.jpg&quot;</span>
<span class="hljs-meta">&gt;&gt;&gt; </span>image = Image.<span class="hljs-built_in">open</span>(requests.get(url, stream=<span class="hljs-literal">True</span>).raw)

<span class="hljs-meta">&gt;&gt;&gt; </span>inputs = processor(images=image, return_tensors=<span class="hljs-string">&quot;pt&quot;</span>).to(device, torch.float16)

<span class="hljs-meta">&gt;&gt;&gt; </span>generated_ids = model.generate(**inputs)
<span class="hljs-meta">&gt;&gt;&gt; </span>generated_text = processor.batch_decode(generated_ids, skip_special_tokens=<span class="hljs-literal">True</span>)[<span class="hljs-number">0</span>].strip()
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-built_in">print</span>(generated_text)
two cats laying on a couch`}}),{c(){h=a("p"),P=n("Image captioning (without providing a text prompt):"),_=c(),b(g.$$.fragment)},l(d){h=s(d,"P",{});var u=i(h);P=r(u,"Image captioning (without providing a text prompt):"),u.forEach(t),_=p(d),$(g.$$.fragment,d)},m(d,u){m(d,h,u),e(h,P),m(d,_,u),B(g,d,u),v=!0},p:Pn,i(d){v||(w(g.$$.fragment,d),v=!0)},o(d){y(g.$$.fragment,d),v=!1},d(d){d&&t(h),d&&t(_),C(g,d)}}}function Pc(F){let h,P,_,g,v;return g=new En({props:{code:`from PIL import Image
import requests
from transformers import Blip2Processor, Blip2ForConditionalGeneration
import torch

device = "cuda" if torch.cuda.is_available() else "cpu"

processor = Blip2Processor.from_pretrained("Salesforce/blip2-opt-2.7b")
model = Blip2ForConditionalGeneration.from_pretrained(
    "Salesforce/blip2-opt-2.7b", torch_dtype=torch.float16
)
model.to(device)
url = "http://images.cocodataset.org/val2017/000000039769.jpg"
image = Image.open(requests.get(url, stream=True).raw)

prompt = "Question: how many cats are there? Answer:"
inputs = processor(images=image, text=prompt, return_tensors="pt").to(device, torch.float16)

generated_ids = model.generate(**inputs)
generated_text = processor.batch_decode(generated_ids, skip_special_tokens=True)[0].strip()
print(generated_text)`,highlighted:`<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">from</span> PIL <span class="hljs-keyword">import</span> Image
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">import</span> requests
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">from</span> transformers <span class="hljs-keyword">import</span> Blip2Processor, Blip2ForConditionalGeneration
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">import</span> torch

<span class="hljs-meta">&gt;&gt;&gt; </span>device = <span class="hljs-string">&quot;cuda&quot;</span> <span class="hljs-keyword">if</span> torch.cuda.is_available() <span class="hljs-keyword">else</span> <span class="hljs-string">&quot;cpu&quot;</span>

<span class="hljs-meta">&gt;&gt;&gt; </span>processor = Blip2Processor.from_pretrained(<span class="hljs-string">&quot;Salesforce/blip2-opt-2.7b&quot;</span>)
<span class="hljs-meta">&gt;&gt;&gt; </span>model = Blip2ForConditionalGeneration.from_pretrained(
<span class="hljs-meta">... </span>    <span class="hljs-string">&quot;Salesforce/blip2-opt-2.7b&quot;</span>, torch_dtype=torch.float16
<span class="hljs-meta">... </span>)
<span class="hljs-meta">&gt;&gt;&gt; </span>model.to(device)
<span class="hljs-meta">&gt;&gt;&gt; </span>url = <span class="hljs-string">&quot;http://images.cocodataset.org/val2017/000000039769.jpg&quot;</span>
<span class="hljs-meta">&gt;&gt;&gt; </span>image = Image.<span class="hljs-built_in">open</span>(requests.get(url, stream=<span class="hljs-literal">True</span>).raw)

<span class="hljs-meta">&gt;&gt;&gt; </span>prompt = <span class="hljs-string">&quot;Question: how many cats are there? Answer:&quot;</span>
<span class="hljs-meta">&gt;&gt;&gt; </span>inputs = processor(images=image, text=prompt, return_tensors=<span class="hljs-string">&quot;pt&quot;</span>).to(device, torch.float16)

<span class="hljs-meta">&gt;&gt;&gt; </span>generated_ids = model.generate(**inputs)
<span class="hljs-meta">&gt;&gt;&gt; </span>generated_text = processor.batch_decode(generated_ids, skip_special_tokens=<span class="hljs-literal">True</span>)[<span class="hljs-number">0</span>].strip()
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-built_in">print</span>(generated_text)
two`}}),{c(){h=a("p"),P=n("Visual question answering (prompt = question):"),_=c(),b(g.$$.fragment)},l(d){h=s(d,"P",{});var u=i(h);P=r(u,"Visual question answering (prompt = question):"),u.forEach(t),_=p(d),$(g.$$.fragment,d)},m(d,u){m(d,h,u),e(h,P),m(d,_,u),B(g,d,u),v=!0},p:Pn,i(d){v||(w(g.$$.fragment,d),v=!0)},o(d){y(g.$$.fragment,d),v=!1},d(d){d&&t(h),d&&t(_),C(g,d)}}}function Ec(F){let h,P,_,g,v,d,u,D,Tr,Tn,ee,ue,wt,Oe,xr,yt,Fr,xn,W,zr,Se,Ir,qr,De,jr,Lr,Fn,Lo,Ar,zn,Ao,Ct,Mr,In,Mo,Qr,qn,_e,Ne,Vr,kt,Or,Sr,Dr,Ge,Nr,Qo,Gr,Wr,jn,ve,yl,Ln,We,Hr,Vo,Rr,An,H,Ur,He,Jr,Kr,Re,Xr,Yr,Mn,oe,be,Pt,Ue,Zr,Et,ea,Qn,Oo,oa,Vn,So,Je,ta,Ke,na,ra,On,Do,aa,Sn,te,$e,Tt,Xe,sa,xt,ia,Dn,q,Ye,la,R,No,da,ca,Go,pa,fa,Ze,ma,ha,ga,ne,ua,Wo,_a,va,Ho,ba,$a,Ba,Be,wa,we,eo,ya,oo,Ca,Ro,ka,Pa,Nn,re,ye,Ft,to,Ea,zt,Ta,Gn,Q,no,xa,ae,Fa,Uo,za,Ia,ro,qa,ja,La,se,Aa,Jo,Ma,Qa,Ko,Va,Oa,Sa,Ce,Wn,ie,ke,It,ao,Da,qt,Na,Hn,V,so,Ga,O,Wa,Xo,Ha,Ra,io,Ua,Ja,Yo,Ka,Xa,Zo,Ya,Za,es,le,os,et,ts,ns,ot,rs,as,ss,Pe,Rn,de,Ee,jt,lo,is,Lt,ls,Un,j,co,ds,At,cs,ps,L,tt,fs,ms,nt,hs,gs,rt,us,_s,Mt,vs,bs,at,$s,Bs,ws,Te,po,ys,fo,Cs,st,ks,Ps,Es,xe,mo,Ts,ho,xs,it,Fs,zs,Jn,ce,Fe,Qt,go,Is,Vt,qs,Kn,pe,uo,js,U,_o,Ls,fe,As,lt,Ms,Qs,Ot,Vs,Os,Ss,ze,Xn,me,Ie,St,vo,Ds,Dt,Ns,Yn,N,bo,Gs,Nt,Ws,Hs,J,$o,Rs,T,Us,Gt,Js,Ks,Wt,Xs,Ys,Ht,Zs,ei,Rt,oi,ti,Ut,ni,ri,Jt,ai,si,Kt,ii,li,di,Bo,wo,ci,Xt,pi,fi,mi,k,hi,Yt,gi,ui,Zt,_i,vi,en,bi,$i,on,Bi,wi,tn,yi,Ci,nn,ki,Pi,rn,Ei,Ti,an,xi,Fi,sn,zi,Ii,ln,qi,ji,dn,Li,Ai,cn,Mi,Qi,pn,Vi,Oi,fn,Si,Di,Zn,he,qe,mn,yo,Ni,hn,Gi,er,x,Co,Wi,gn,Hi,Ri,ko,Ui,un,Ji,Ki,Xi,Po,Yi,dt,Zi,el,ol,Eo,tl,To,nl,rl,al,z,xo,sl,ge,il,ct,ll,dl,_n,cl,pl,fl,je,ml,vn,hl,gl,Le,ul,Ae,_l,Me,Fo,vl,zo,bl,bn,$l,Bl,or;return d=new Z({}),Oe=new Z({}),Ue=new Z({}),Xe=new Z({}),Ye=new M({props:{name:"class transformers.Blip2Config",anchor:"transformers.Blip2Config",parameters:[{name:"vision_config",val:" = None"},{name:"qformer_config",val:" = None"},{name:"text_config",val:" = None"},{name:"num_query_tokens",val:" = 32"},{name:"**kwargs",val:""}],parametersDescription:[{anchor:"transformers.Blip2Config.vision_config",description:`<strong>vision_config</strong> (<code>dict</code>, <em>optional</em>) &#x2014;
Dictionary of configuration options used to initialize <a href="/docs/transformers/main/en/model_doc/blip-2#transformers.Blip2VisionConfig">Blip2VisionConfig</a>.`,name:"vision_config"},{anchor:"transformers.Blip2Config.qformer_config",description:`<strong>qformer_config</strong> (<code>dict</code>, <em>optional</em>) &#x2014;
Dictionary of configuration options used to initialize <a href="/docs/transformers/main/en/model_doc/blip-2#transformers.Blip2QFormerConfig">Blip2QFormerConfig</a>.`,name:"qformer_config"},{anchor:"transformers.Blip2Config.text_config",description:`<strong>text_config</strong> (<code>dict</code>, <em>optional</em>) &#x2014;
Dictionary of configuration options used to initialize any <a href="/docs/transformers/main/en/main_classes/configuration#transformers.PretrainedConfig">PretrainedConfig</a>.`,name:"text_config"},{anchor:"transformers.Blip2Config.num_query_tokens",description:`<strong>num_query_tokens</strong> (<code>int</code>, <em>optional</em>, defaults to 32) &#x2014;
The number of query tokens passed through the Transformer.`,name:"num_query_tokens"},{anchor:"transformers.Blip2Config.kwargs",description:`<strong>kwargs</strong> (<em>optional</em>) &#x2014;
Dictionary of keyword arguments.`,name:"kwargs"}],source:"https://github.com/huggingface/transformers/blob/main/src/transformers/models/blip_2/configuration_blip_2.py#L265"}}),Be=new kn({props:{anchor:"transformers.Blip2Config.example",$$slots:{default:[$c]},$$scope:{ctx:F}}}),eo=new M({props:{name:"from_vision_qformer_text_configs",anchor:"transformers.Blip2Config.from_vision_qformer_text_configs",parameters:[{name:"vision_config",val:": Blip2VisionConfig"},{name:"qformer_config",val:": Blip2QFormerConfig"},{name:"text_config",val:": PretrainedConfig"},{name:"**kwargs",val:""}],source:"https://github.com/huggingface/transformers/blob/main/src/transformers/models/blip_2/configuration_blip_2.py#L347",returnDescription:`
<p>An instance of a configuration object</p>
`,returnType:`
<p><a
  href="/docs/transformers/main/en/model_doc/blip-2#transformers.Blip2Config"
>Blip2Config</a></p>
`}}),to=new Z({}),no=new M({props:{name:"class transformers.Blip2VisionConfig",anchor:"transformers.Blip2VisionConfig",parameters:[{name:"hidden_size",val:" = 1408"},{name:"intermediate_size",val:" = 6144"},{name:"projection_dim",val:" = 512"},{name:"num_hidden_layers",val:" = 39"},{name:"num_attention_heads",val:" = 16"},{name:"num_channels",val:" = 3"},{name:"image_size",val:" = 224"},{name:"patch_size",val:" = 14"},{name:"hidden_act",val:" = 'gelu'"},{name:"layer_norm_eps",val:" = 1e-05"},{name:"dropout",val:" = 0.0"},{name:"attention_dropout",val:" = 0.0"},{name:"initializer_range",val:" = 1e-10"},{name:"initializer_factor",val:" = 1.0"},{name:"qkv_bias",val:" = True"},{name:"**kwargs",val:""}],parametersDescription:[{anchor:"transformers.Blip2VisionConfig.hidden_size",description:`<strong>hidden_size</strong> (<code>int</code>, <em>optional</em>, defaults to 1408) &#x2014;
Dimensionality of the encoder layers and the pooler layer.`,name:"hidden_size"},{anchor:"transformers.Blip2VisionConfig.intermediate_size",description:`<strong>intermediate_size</strong> (<code>int</code>, <em>optional</em>, defaults to 6144) &#x2014;
Dimensionality of the &#x201C;intermediate&#x201D; (i.e., feed-forward) layer in the Transformer encoder.`,name:"intermediate_size"},{anchor:"transformers.Blip2VisionConfig.num_hidden_layers",description:`<strong>num_hidden_layers</strong> (<code>int</code>, <em>optional</em>, defaults to 39) &#x2014;
Number of hidden layers in the Transformer encoder.`,name:"num_hidden_layers"},{anchor:"transformers.Blip2VisionConfig.num_attention_heads",description:`<strong>num_attention_heads</strong> (<code>int</code>, <em>optional</em>, defaults to 16) &#x2014;
Number of attention heads for each attention layer in the Transformer encoder.`,name:"num_attention_heads"},{anchor:"transformers.Blip2VisionConfig.image_size",description:`<strong>image_size</strong> (<code>int</code>, <em>optional</em>, defaults to 224) &#x2014;
The size (resolution) of each image.`,name:"image_size"},{anchor:"transformers.Blip2VisionConfig.patch_size",description:`<strong>patch_size</strong> (<code>int</code>, <em>optional</em>, defaults to 14) &#x2014;
The size (resolution) of each patch.`,name:"patch_size"},{anchor:"transformers.Blip2VisionConfig.hidden_act",description:`<strong>hidden_act</strong> (<code>str</code> or <code>function</code>, <em>optional</em>, defaults to <code>&quot;gelu&quot;</code>) &#x2014;
The non-linear activation function (function or string) in the encoder and pooler. If string, <code>&quot;gelu&quot;</code>,
<code>&quot;relu&quot;</code>, <code>&quot;selu&quot;</code> and <code>&quot;gelu_new&quot;</code> \`<code>&quot;gelu&quot;</code> are supported. layer_norm_eps (<code>float</code>, <em>optional</em>, defaults
to 1e-5): The epsilon used by the layer normalization layers.`,name:"hidden_act"},{anchor:"transformers.Blip2VisionConfig.dropout",description:`<strong>dropout</strong> (<code>float</code>, <em>optional</em>, defaults to 0.0) &#x2014;
The dropout probabilitiy for all fully connected layers in the embeddings, encoder, and pooler.`,name:"dropout"},{anchor:"transformers.Blip2VisionConfig.attention_dropout",description:`<strong>attention_dropout</strong> (<code>float</code>, <em>optional</em>, defaults to 0.0) &#x2014;
The dropout ratio for the attention probabilities.`,name:"attention_dropout"},{anchor:"transformers.Blip2VisionConfig.initializer_range",description:`<strong>initializer_range</strong> (<code>float</code>, <em>optional</em>, defaults to 0.02) &#x2014;
The standard deviation of the truncated_normal_initializer for initializing all weight matrices.`,name:"initializer_range"},{anchor:"transformers.Blip2VisionConfig.initializer_factor",description:`<strong>initializer_factor</strong> (\`float&#x201C;, <em>optional</em>, defaults to 1) &#x2014;
A factor for initializing all weight matrices (should be kept to 1, used internally for initialization
testing).`,name:"initializer_factor"},{anchor:"transformers.Blip2VisionConfig.qkv_bias",description:`<strong>qkv_bias</strong> (<code>bool</code>, <em>optional</em>, defaults to <code>True</code>) &#x2014;
Whether to add a bias to the queries and values in the self-attention layers.`,name:"qkv_bias"}],source:"https://github.com/huggingface/transformers/blob/main/src/transformers/models/blip_2/configuration_blip_2.py#L35"}}),Ce=new kn({props:{anchor:"transformers.Blip2VisionConfig.example",$$slots:{default:[Bc]},$$scope:{ctx:F}}}),ao=new Z({}),so=new M({props:{name:"class transformers.Blip2QFormerConfig",anchor:"transformers.Blip2QFormerConfig",parameters:[{name:"vocab_size",val:" = 30522"},{name:"hidden_size",val:" = 768"},{name:"num_hidden_layers",val:" = 12"},{name:"num_attention_heads",val:" = 12"},{name:"intermediate_size",val:" = 3072"},{name:"hidden_act",val:" = 'gelu'"},{name:"hidden_dropout_prob",val:" = 0.1"},{name:"attention_probs_dropout_prob",val:" = 0.1"},{name:"max_position_embeddings",val:" = 512"},{name:"initializer_range",val:" = 0.02"},{name:"layer_norm_eps",val:" = 1e-12"},{name:"pad_token_id",val:" = 0"},{name:"position_embedding_type",val:" = 'absolute'"},{name:"classifier_dropout",val:" = None"},{name:"cross_attention_frequency",val:" = 2"},{name:"encoder_hidden_size",val:" = 1408"},{name:"**kwargs",val:""}],parametersDescription:[{anchor:"transformers.Blip2QFormerConfig.vocab_size",description:`<strong>vocab_size</strong> (<code>int</code>, <em>optional</em>, defaults to 30522) &#x2014;
Vocabulary size of the Q-Former model. Defines the number of different tokens that can be represented by
the <code>inputs_ids</code> passed when calling the model.`,name:"vocab_size"},{anchor:"transformers.Blip2QFormerConfig.hidden_size",description:`<strong>hidden_size</strong> (<code>int</code>, <em>optional</em>, defaults to 768) &#x2014;
Dimensionality of the encoder layers and the pooler layer.`,name:"hidden_size"},{anchor:"transformers.Blip2QFormerConfig.num_hidden_layers",description:`<strong>num_hidden_layers</strong> (<code>int</code>, <em>optional</em>, defaults to 12) &#x2014;
Number of hidden layers in the Transformer encoder.`,name:"num_hidden_layers"},{anchor:"transformers.Blip2QFormerConfig.num_attention_heads",description:`<strong>num_attention_heads</strong> (<code>int</code>, <em>optional</em>, defaults to 12) &#x2014;
Number of attention heads for each attention layer in the Transformer encoder.`,name:"num_attention_heads"},{anchor:"transformers.Blip2QFormerConfig.intermediate_size",description:`<strong>intermediate_size</strong> (<code>int</code>, <em>optional</em>, defaults to 3072) &#x2014;
Dimensionality of the &#x201C;intermediate&#x201D; (often named feed-forward) layer in the Transformer encoder.`,name:"intermediate_size"},{anchor:"transformers.Blip2QFormerConfig.hidden_act",description:`<strong>hidden_act</strong> (<code>str</code> or <code>Callable</code>, <em>optional</em>, defaults to <code>&quot;gelu&quot;</code>) &#x2014;
The non-linear activation function (function or string) in the encoder and pooler. If string, <code>&quot;gelu&quot;</code>,
<code>&quot;relu&quot;</code>, <code>&quot;silu&quot;</code> and <code>&quot;gelu_new&quot;</code> are supported.`,name:"hidden_act"},{anchor:"transformers.Blip2QFormerConfig.hidden_dropout_prob",description:`<strong>hidden_dropout_prob</strong> (<code>float</code>, <em>optional</em>, defaults to 0.1) &#x2014;
The dropout probability for all fully connected layers in the embeddings, encoder, and pooler.`,name:"hidden_dropout_prob"},{anchor:"transformers.Blip2QFormerConfig.attention_probs_dropout_prob",description:`<strong>attention_probs_dropout_prob</strong> (<code>float</code>, <em>optional</em>, defaults to 0.1) &#x2014;
The dropout ratio for the attention probabilities.`,name:"attention_probs_dropout_prob"},{anchor:"transformers.Blip2QFormerConfig.max_position_embeddings",description:`<strong>max_position_embeddings</strong> (<code>int</code>, <em>optional</em>, defaults to 512) &#x2014;
The maximum sequence length that this model might ever be used with. Typically set this to something large
just in case (e.g., 512 or 1024 or 2048).`,name:"max_position_embeddings"},{anchor:"transformers.Blip2QFormerConfig.initializer_range",description:`<strong>initializer_range</strong> (<code>float</code>, <em>optional</em>, defaults to 0.02) &#x2014;
The standard deviation of the truncated_normal_initializer for initializing all weight matrices.`,name:"initializer_range"},{anchor:"transformers.Blip2QFormerConfig.layer_norm_eps",description:`<strong>layer_norm_eps</strong> (<code>float</code>, <em>optional</em>, defaults to 1e-12) &#x2014;
The epsilon used by the layer normalization layers.`,name:"layer_norm_eps"},{anchor:"transformers.Blip2QFormerConfig.position_embedding_type",description:`<strong>position_embedding_type</strong> (<code>str</code>, <em>optional</em>, defaults to <code>&quot;absolute&quot;</code>) &#x2014;
Type of position embedding. Choose one of <code>&quot;absolute&quot;</code>, <code>&quot;relative_key&quot;</code>, <code>&quot;relative_key_query&quot;</code>. For
positional embeddings use <code>&quot;absolute&quot;</code>. For more information on <code>&quot;relative_key&quot;</code>, please refer to
<a href="https://arxiv.org/abs/1803.02155" rel="nofollow">Self-Attention with Relative Position Representations (Shaw et al.)</a>.
For more information on <code>&quot;relative_key_query&quot;</code>, please refer to <em>Method 4</em> in <a href="https://arxiv.org/abs/2009.13658" rel="nofollow">Improve Transformer Models
with Better Relative Position Embeddings (Huang et al.)</a>.`,name:"position_embedding_type"},{anchor:"transformers.Blip2QFormerConfig.classifier_dropout",description:`<strong>classifier_dropout</strong> (<code>float</code>, <em>optional</em>) &#x2014;
The dropout ratio for the classification head.`,name:"classifier_dropout"},{anchor:"transformers.Blip2QFormerConfig.cross_attention_frequency",description:`<strong>cross_attention_frequency</strong> (<code>int</code>, <em>optional</em>, defaults to 2) &#x2014;
The frequency of adding cross-attention to the Transformer layers.`,name:"cross_attention_frequency"},{anchor:"transformers.Blip2QFormerConfig.encoder_hidden_size",description:`<strong>encoder_hidden_size</strong> (<code>int</code>, <em>optional</em>, defaults to 1408) &#x2014;
The hidden size of the hidden states for cross-attention.`,name:"encoder_hidden_size"}],source:"https://github.com/huggingface/transformers/blob/main/src/transformers/models/blip_2/configuration_blip_2.py#L145"}}),Pe=new kn({props:{anchor:"transformers.Blip2QFormerConfig.example",$$slots:{default:[wc]},$$scope:{ctx:F}}}),lo=new Z({}),co=new M({props:{name:"class transformers.Blip2Processor",anchor:"transformers.Blip2Processor",parameters:[{name:"image_processor",val:""},{name:"tokenizer",val:""}],parametersDescription:[{anchor:"transformers.Blip2Processor.image_processor",description:`<strong>image_processor</strong> (<code>BlipImageProcessor</code>) &#x2014;
An instance of <a href="/docs/transformers/main/en/model_doc/blip#transformers.BlipImageProcessor">BlipImageProcessor</a>. The image processor is a required input.`,name:"image_processor"},{anchor:"transformers.Blip2Processor.tokenizer",description:"<strong>tokenizer</strong> (<code>AutoTokenizer</code>) &#x2014;\nAn instance of [&#x2018;PreTrainedTokenizer`]. The tokenizer is a required input.",name:"tokenizer"}],source:"https://github.com/huggingface/transformers/blob/main/src/transformers/models/blip_2/processing_blip_2.py#L26"}}),po=new M({props:{name:"batch_decode",anchor:"transformers.Blip2Processor.batch_decode",parameters:[{name:"*args",val:""},{name:"**kwargs",val:""}],source:"https://github.com/huggingface/transformers/blob/main/src/transformers/models/blip_2/processing_blip_2.py#L133"}}),mo=new M({props:{name:"decode",anchor:"transformers.Blip2Processor.decode",parameters:[{name:"*args",val:""},{name:"**kwargs",val:""}],source:"https://github.com/huggingface/transformers/blob/main/src/transformers/models/blip_2/processing_blip_2.py#L141"}}),go=new Z({}),uo=new M({props:{name:"class transformers.Blip2VisionModel",anchor:"transformers.Blip2VisionModel",parameters:[{name:"config",val:": Blip2VisionConfig"}],source:"https://github.com/huggingface/transformers/blob/main/src/transformers/models/blip_2/modeling_blip_2.py#L486"}}),_o=new M({props:{name:"forward",anchor:"transformers.Blip2VisionModel.forward",parameters:[{name:"pixel_values",val:": typing.Optional[torch.FloatTensor] = None"},{name:"output_attentions",val:": typing.Optional[bool] = None"},{name:"output_hidden_states",val:": typing.Optional[bool] = None"},{name:"return_dict",val:": typing.Optional[bool] = None"}],parametersDescription:[{anchor:"transformers.Blip2VisionModel.forward.pixel_values",description:`<strong>pixel_values</strong> (<code>torch.FloatTensor</code> of shape <code>(batch_size, num_channels, height, width)</code>) &#x2014;
Pixel values. Pixel values can be obtained using <a href="/docs/transformers/main/en/model_doc/blip-2#transformers.Blip2Processor">Blip2Processor</a>. See <code>Blip2Processor.__call__()</code> for
details.`,name:"pixel_values"},{anchor:"transformers.Blip2VisionModel.forward.output_attentions",description:`<strong>output_attentions</strong> (<code>bool</code>, <em>optional</em>) &#x2014;
Whether or not to return the attentions tensors of all attention layers. See <code>attentions</code> under returned
tensors for more detail.`,name:"output_attentions"},{anchor:"transformers.Blip2VisionModel.forward.output_hidden_states",description:`<strong>output_hidden_states</strong> (<code>bool</code>, <em>optional</em>) &#x2014;
Whether or not to return the hidden states of all layers. See <code>hidden_states</code> under returned tensors for
more detail.`,name:"output_hidden_states"},{anchor:"transformers.Blip2VisionModel.forward.return_dict",description:`<strong>return_dict</strong> (<code>bool</code>, <em>optional</em>) &#x2014;
Whether or not to return a <a href="/docs/transformers/main/en/main_classes/output#transformers.utils.ModelOutput">ModelOutput</a> instead of a plain tuple.`,name:"return_dict"}],source:"https://github.com/huggingface/transformers/blob/main/src/transformers/models/blip_2/modeling_blip_2.py#L501",returnDescription:`
<p>A <a
  href="/docs/transformers/main/en/main_classes/output#transformers.modeling_outputs.BaseModelOutputWithPooling"
>transformers.modeling_outputs.BaseModelOutputWithPooling</a> or a tuple of
<code>torch.FloatTensor</code> (if <code>return_dict=False</code> is passed or when <code>config.return_dict=False</code>) comprising various
elements depending on the configuration (<code>&lt;class 'transformers.models.blip_2.configuration_blip_2.Blip2VisionConfig'&gt;</code>) and inputs.</p>
<ul>
<li>
<p><strong>last_hidden_state</strong> (<code>torch.FloatTensor</code> of shape <code>(batch_size, sequence_length, hidden_size)</code>) \u2014 Sequence of hidden-states at the output of the last layer of the model.</p>
</li>
<li>
<p><strong>pooler_output</strong> (<code>torch.FloatTensor</code> of shape <code>(batch_size, hidden_size)</code>) \u2014 Last layer hidden-state of the first token of the sequence (classification token) after further processing
through the layers used for the auxiliary pretraining task. E.g. for BERT-family of models, this returns
the classification token after processing through a linear layer and a tanh activation function. The linear
layer weights are trained from the next sentence prediction (classification) objective during pretraining.</p>
</li>
<li>
<p><strong>hidden_states</strong> (<code>tuple(torch.FloatTensor)</code>, <em>optional</em>, returned when <code>output_hidden_states=True</code> is passed or when <code>config.output_hidden_states=True</code>) \u2014 Tuple of <code>torch.FloatTensor</code> (one for the output of the embeddings, if the model has an embedding layer, +
one for the output of each layer) of shape <code>(batch_size, sequence_length, hidden_size)</code>.</p>
<p>Hidden-states of the model at the output of each layer plus the optional initial embedding outputs.</p>
</li>
<li>
<p><strong>attentions</strong> (<code>tuple(torch.FloatTensor)</code>, <em>optional</em>, returned when <code>output_attentions=True</code> is passed or when <code>config.output_attentions=True</code>) \u2014 Tuple of <code>torch.FloatTensor</code> (one for each layer) of shape <code>(batch_size, num_heads, sequence_length, sequence_length)</code>.</p>
<p>Attentions weights after the attention softmax, used to compute the weighted average in the self-attention
heads.</p>
</li>
</ul>
`,returnType:`
<p><a
  href="/docs/transformers/main/en/main_classes/output#transformers.modeling_outputs.BaseModelOutputWithPooling"
>transformers.modeling_outputs.BaseModelOutputWithPooling</a> or <code>tuple(torch.FloatTensor)</code></p>
`}}),ze=new mc({props:{$$slots:{default:[yc]},$$scope:{ctx:F}}}),vo=new Z({}),bo=new M({props:{name:"class transformers.Blip2QFormerModel",anchor:"transformers.Blip2QFormerModel",parameters:[{name:"config",val:": Blip2QFormerConfig"}],source:"https://github.com/huggingface/transformers/blob/main/src/transformers/models/blip_2/modeling_blip_2.py#L981"}}),$o=new M({props:{name:"forward",anchor:"transformers.Blip2QFormerModel.forward",parameters:[{name:"query_embeds",val:""},{name:"attention_mask",val:" = None"},{name:"head_mask",val:" = None"},{name:"encoder_hidden_states",val:" = None"},{name:"encoder_attention_mask",val:" = None"},{name:"past_key_values",val:" = None"},{name:"use_cache",val:" = None"},{name:"output_attentions",val:" = None"},{name:"output_hidden_states",val:" = None"},{name:"return_dict",val:" = None"}],source:"https://github.com/huggingface/transformers/blob/main/src/transformers/models/blip_2/modeling_blip_2.py#L1056"}}),yo=new Z({}),Co=new M({props:{name:"class transformers.Blip2ForConditionalGeneration",anchor:"transformers.Blip2ForConditionalGeneration",parameters:[{name:"config",val:": Blip2Config"}],parametersDescription:[{anchor:"transformers.Blip2ForConditionalGeneration.config",description:`<strong>config</strong> (<a href="/docs/transformers/main/en/model_doc/blip-2#transformers.Blip2Config">Blip2Config</a>) &#x2014; Model configuration class with all the parameters of the model.
Initializing with a config file does not load the weights associated with the model, only the
configuration. Check out the <a href="/docs/transformers/main/en/main_classes/model#transformers.PreTrainedModel.from_pretrained">from_pretrained()</a> method to load the model weights.`,name:"config"}],source:"https://github.com/huggingface/transformers/blob/main/src/transformers/models/blip_2/modeling_blip_2.py#L1184"}}),xo=new M({props:{name:"forward",anchor:"transformers.Blip2ForConditionalGeneration.forward",parameters:[{name:"pixel_values",val:": FloatTensor"},{name:"input_ids",val:": FloatTensor"},{name:"attention_mask",val:": typing.Optional[torch.LongTensor] = None"},{name:"decoder_input_ids",val:": typing.Optional[torch.LongTensor] = None"},{name:"decoder_attention_mask",val:": typing.Optional[torch.LongTensor] = None"},{name:"output_attentions",val:": typing.Optional[bool] = None"},{name:"output_hidden_states",val:": typing.Optional[bool] = None"},{name:"labels",val:": typing.Optional[torch.LongTensor] = None"},{name:"return_dict",val:": typing.Optional[bool] = None"}],parametersDescription:[{anchor:"transformers.Blip2ForConditionalGeneration.forward.pixel_values",description:`<strong>pixel_values</strong> (<code>torch.FloatTensor</code> of shape <code>(batch_size, num_channels, height, width)</code>) &#x2014;
Pixel values. Pixel values can be obtained using <a href="/docs/transformers/main/en/model_doc/blip-2#transformers.Blip2Processor">Blip2Processor</a>. See <code>Blip2Processor.__call__()</code> for
details.`,name:"pixel_values"},{anchor:"transformers.Blip2ForConditionalGeneration.forward.input_ids",description:`<strong>input_ids</strong> (<code>torch.LongTensor</code> of shape <code>(batch_size, sequence_length)</code>, <em>optional</em>) &#x2014;
Indices of input sequence tokens in the vocabulary of the language model. Input tokens can optionally be
provided to serve as text prompt, which the language model can continue.</p>
<p>Indices can be obtained using <a href="/docs/transformers/main/en/model_doc/blip-2#transformers.Blip2Processor">Blip2Processor</a>. See <code>Blip2Processor.__call__()</code> for details.</p>
<p><a href="../glossary#input-ids">What are input IDs?</a>`,name:"input_ids"},{anchor:"transformers.Blip2ForConditionalGeneration.forward.attention_mask",description:`<strong>attention_mask</strong> (<code>torch.Tensor</code> of shape <code>(batch_size, sequence_length)</code>, <em>optional</em>) &#x2014;
Mask to avoid performing attention on padding token indices. Mask values selected in <code>[0, 1]</code>:</p>
<ul>
<li>1 for tokens that are <strong>not masked</strong>,</li>
<li>0 for tokens that are <strong>masked</strong>.</li>
</ul>
<p><a href="../glossary#attention-mask">What are attention masks?</a>`,name:"attention_mask"},{anchor:"transformers.Blip2ForConditionalGeneration.forward.decoder_input_ids",description:`<strong>decoder_input_ids</strong> (<code>torch.LongTensor</code> of shape <code>(batch_size, target_sequence_length)</code>, <em>optional</em>) &#x2014;
Indices of decoder input sequence tokens in the vocabulary of the language model. Only relevant in case an
encoder-decoder language model (like T5) is used.</p>
<p>Indices can be obtained using <a href="/docs/transformers/main/en/model_doc/auto#transformers.AutoTokenizer">AutoTokenizer</a>. See <a href="/docs/transformers/main/en/internal/tokenization_utils#transformers.PreTrainedTokenizerBase.encode">PreTrainedTokenizer.encode()</a> and
<a href="/docs/transformers/main/en/internal/tokenization_utils#transformers.PreTrainedTokenizerBase.__call__">PreTrainedTokenizer.<strong>call</strong>()</a> for details. <a href="../glossary#decoder-input-ids">What are decoder input IDs?</a>`,name:"decoder_input_ids"},{anchor:"transformers.Blip2ForConditionalGeneration.forward.decoder_attention_mask",description:`<strong>decoder_attention_mask</strong> (<code>torch.BoolTensor</code> of shape <code>(batch_size, target_sequence_length)</code>, <em>optional</em>) &#x2014;
Default behavior: generate a tensor that ignores pad tokens in <code>decoder_input_ids</code>. Causal mask will also
be used by default.</p>
<p>Only relevant in case an encoder-decoder language model (like T5) is used.`,name:"decoder_attention_mask"},{anchor:"transformers.Blip2ForConditionalGeneration.forward.output_attentions",description:`<strong>output_attentions</strong> (<code>bool</code>, <em>optional</em>) &#x2014;
Whether or not to return the attentions tensors of all attention layers. See <code>attentions</code> under returned
tensors for more detail.`,name:"output_attentions"},{anchor:"transformers.Blip2ForConditionalGeneration.forward.output_hidden_states",description:`<strong>output_hidden_states</strong> (<code>bool</code>, <em>optional</em>) &#x2014;
Whether or not to return the hidden states of all layers. See <code>hidden_states</code> under returned tensors for
more detail.`,name:"output_hidden_states"},{anchor:"transformers.Blip2ForConditionalGeneration.forward.return_dict",description:`<strong>return_dict</strong> (<code>bool</code>, <em>optional</em>) &#x2014;
Whether or not to return a <a href="/docs/transformers/main/en/main_classes/output#transformers.utils.ModelOutput">ModelOutput</a> instead of a plain tuple.`,name:"return_dict"}],source:"https://github.com/huggingface/transformers/blob/main/src/transformers/models/blip_2/modeling_blip_2.py#L1209",returnDescription:`
<p>A <code>transformers.models.blip_2.modeling_blip_2.Blip2ForConditionalGenerationModelOutput</code> or a tuple of
<code>torch.FloatTensor</code> (if <code>return_dict=False</code> is passed or when <code>config.return_dict=False</code>) comprising various
elements depending on the configuration (<code>&lt;class 'transformers.models.blip_2.configuration_blip_2.Blip2VisionConfig'&gt;</code>) and inputs.</p>
<ul>
<li><strong>loss</strong> (<code>torch.FloatTensor</code>, <em>optional</em>, returned when <code>labels</code> is provided, <code>torch.FloatTensor</code> of shape <code>(1,)</code>) \u2014 Language modeling loss from the language model.</li>
<li><strong>logits</strong> (<code>torch.FloatTensor</code> of shape <code>(batch_size, sequence_length, config.vocab_size)</code>) \u2014 Prediction scores of the language modeling head of the language model.</li>
<li><strong>vision_outputs</strong> (<code>BaseModelOutputWithPooling</code>) \u2014 Outputs of the vision encoder.</li>
<li><strong>qformer_outputs</strong> (<code>BaseModelOutputWithPoolingAndCrossAttentions</code>) \u2014 Outputs of the Q-Former (Querying Transformer).</li>
<li><strong>language_model_outputs</strong> (<code>CausalLMOutputWithPast</code> or <code>Seq2SeqLMOutput</code>) \u2014 Outputs of the language model.</li>
</ul>
`,returnType:`
<p><code>transformers.models.blip_2.modeling_blip_2.Blip2ForConditionalGenerationModelOutput</code> or <code>tuple(torch.FloatTensor)</code></p>
`}}),je=new mc({props:{$$slots:{default:[Cc]},$$scope:{ctx:F}}}),Le=new kn({props:{anchor:"transformers.Blip2ForConditionalGeneration.forward.example",$$slots:{default:[kc]},$$scope:{ctx:F}}}),Ae=new kn({props:{anchor:"transformers.Blip2ForConditionalGeneration.forward.example-2",$$slots:{default:[Pc]},$$scope:{ctx:F}}}),Fo=new M({props:{name:"generate",anchor:"transformers.Blip2ForConditionalGeneration.generate",parameters:[{name:"pixel_values",val:": FloatTensor"},{name:"input_ids",val:": typing.Optional[torch.LongTensor] = None"},{name:"attention_mask",val:": typing.Optional[torch.LongTensor] = None"},{name:"**generate_kwargs",val:""}],parametersDescription:[{anchor:"transformers.Blip2ForConditionalGeneration.generate.pixel_values",description:`<strong>pixel_values</strong> (<code>torch.FloatTensor</code> of shape (batch_size, num_channels, height, width)) &#x2014;
Input images to be processed.`,name:"pixel_values"},{anchor:"transformers.Blip2ForConditionalGeneration.generate.input_ids",description:`<strong>input_ids</strong> (<code>torch.LongTensor</code> of shape (batch_size, sequence_length), <em>optional</em>) &#x2014;
The sequence used as a prompt for the generation.`,name:"input_ids"},{anchor:"transformers.Blip2ForConditionalGeneration.generate.attention_mask",description:`<strong>attention_mask</strong> (<code>torch.LongTensor</code> of shape (batch_size, sequence_length), <em>optional</em>) &#x2014;
Mask to avoid performing attention on padding token indices`,name:"attention_mask"}],source:"https://github.com/huggingface/transformers/blob/main/src/transformers/models/blip_2/modeling_blip_2.py#L1368",returnDescription:`
<p>A list of strings of length batch_size * num_captions.</p>
`,returnType:`
<p>captions (list)</p>
`}}),{c(){h=a("meta"),P=c(),_=a("h1"),g=a("a"),v=a("span"),b(d.$$.fragment),u=c(),D=a("span"),Tr=n("BLIP-2"),Tn=c(),ee=a("h2"),ue=a("a"),wt=a("span"),b(Oe.$$.fragment),xr=c(),yt=a("span"),Fr=n("Overview"),xn=c(),W=a("p"),zr=n("The BLIP-2 model was proposed in "),Se=a("a"),Ir=n("BLIP-2: Bootstrapping Language-Image Pre-training with Frozen Image Encoders and Large Language Models"),qr=n(` by
Junnan Li, Dongxu Li, Silvio Savarese, Steven Hoi. BLIP-2 leverages frozen pre-trained image encoders and large language models (LLMs) by training a lightweight, 12-layer Transformer
encoder in between them, achieving state-of-the-art performance on various vision-language tasks. Most notably, BLIP-2 improves upon `),De=a("a"),jr=n("Flamingo"),Lr=n(`, an 80 billion parameter model, by 8.7%
on zero-shot VQAv2 with 54x fewer trainable parameters.`),Fn=c(),Lo=a("p"),Ar=n("The abstract from the paper is the following:"),zn=c(),Ao=a("p"),Ct=a("em"),Mr=n("The cost of vision-and-language pre-training has become increasingly prohibitive due to end-to-end training of large-scale models. This paper proposes BLIP-2, a generic and efficient pre-training strategy that bootstraps vision-language pre-training from off-the-shelf frozen pre-trained image encoders and frozen large language models. BLIP-2 bridges the modality gap with a lightweight Querying Transformer, which is pre-trained in two stages. The first stage bootstraps vision-language representation learning from a frozen image encoder. The second stage bootstraps vision-to-language generative learning from a frozen language model. BLIP-2 achieves state-of-the-art performance on various vision-language tasks, despite having significantly fewer trainable parameters than existing methods. For example, our model outperforms Flamingo80B by 8.7% on zero-shot VQAv2 with 54x fewer trainable parameters. We also demonstrate the model\u2019s emerging capabilities of zero-shot image-to-text generation that can follow natural language instructions."),In=c(),Mo=a("p"),Qr=n("Tips:"),qn=c(),_e=a("ul"),Ne=a("li"),Vr=n("BLIP-2 can be used for conditional text generation given an image and an optional text prompt. At inference time, it\u2019s recommended to use the "),kt=a("code"),Or=n("generate"),Sr=n(" method."),Dr=c(),Ge=a("li"),Nr=n("One can use "),Qo=a("a"),Gr=n("Blip2Processor"),Wr=n(" to prepare images for the model, and decode the predicted tokens ID\u2019s back to text."),jn=c(),ve=a("img"),Ln=c(),We=a("small"),Hr=n("BLIP-2 architecture. Taken from the "),Vo=a("a"),Rr=n("original paper."),An=c(),H=a("p"),Ur=n("This model was contributed by "),He=a("a"),Jr=n("nielsr"),Kr=n(`.
The original code can be found `),Re=a("a"),Xr=n("here"),Yr=n("."),Mn=c(),oe=a("h2"),be=a("a"),Pt=a("span"),b(Ue.$$.fragment),Zr=c(),Et=a("span"),ea=n("Resources"),Qn=c(),Oo=a("p"),oa=n("A list of official Hugging Face and community (indicated by \u{1F30E}) resources to help you get started with BLIP-2."),Vn=c(),So=a("ul"),Je=a("li"),ta=n("Demo notebooks for BLIP-2 for image captioning, visual question answering (VQA) and chat-like conversations can be found "),Ke=a("a"),na=n("here"),ra=n("."),On=c(),Do=a("p"),aa=n("If you\u2019re interested in submitting a resource to be included here, please feel free to open a Pull Request and we\u2019ll review it! The resource should ideally demonstrate something new instead of duplicating an existing resource."),Sn=c(),te=a("h2"),$e=a("a"),Tt=a("span"),b(Xe.$$.fragment),sa=c(),xt=a("span"),ia=n("Blip2Config"),Dn=c(),q=a("div"),b(Ye.$$.fragment),la=c(),R=a("p"),No=a("a"),da=n("Blip2Config"),ca=n(" is the configuration class to store the configuration of a "),Go=a("a"),pa=n("Blip2ForConditionalGeneration"),fa=n(`. It is
used to instantiate a BLIP-2 model according to the specified arguments, defining the vision model, Q-Former model
and language model configs. Instantiating a configuration with the defaults will yield a similar configuration to
that of the BLIP-2 `),Ze=a("a"),ma=n("Salesforce/blip2-opt-2.7b"),ha=n(" architecture."),ga=c(),ne=a("p"),ua=n("Configuration objects inherit from "),Wo=a("a"),_a=n("PretrainedConfig"),va=n(` and can be used to control the model outputs. Read the
documentation from `),Ho=a("a"),ba=n("PretrainedConfig"),$a=n(" for more information."),Ba=c(),b(Be.$$.fragment),wa=c(),we=a("div"),b(eo.$$.fragment),ya=c(),oo=a("p"),Ca=n("Instantiate a "),Ro=a("a"),ka=n("Blip2Config"),Pa=n(` (or a derived class) from a BLIP-2 vision model, Q-Former and language model
configurations.`),Nn=c(),re=a("h2"),ye=a("a"),Ft=a("span"),b(to.$$.fragment),Ea=c(),zt=a("span"),Ta=n("Blip2VisionConfig"),Gn=c(),Q=a("div"),b(no.$$.fragment),xa=c(),ae=a("p"),Fa=n("This is the configuration class to store the configuration of a "),Uo=a("a"),za=n("Blip2VisionModel"),Ia=n(`. It is used to instantiate a
BLIP-2 vision encoder according to the specified arguments, defining the model architecture. Instantiating a
configuration defaults will yield a similar configuration to that of the BLIP-2
`),ro=a("a"),qa=n("Salesforce/blip2-opt-2.7b"),ja=n(" architecture."),La=c(),se=a("p"),Aa=n("Configuration objects inherit from "),Jo=a("a"),Ma=n("PretrainedConfig"),Qa=n(` and can be used to control the model outputs. Read the
documentation from `),Ko=a("a"),Va=n("PretrainedConfig"),Oa=n(" for more information."),Sa=c(),b(Ce.$$.fragment),Wn=c(),ie=a("h2"),ke=a("a"),It=a("span"),b(ao.$$.fragment),Da=c(),qt=a("span"),Na=n("Blip2QFormerConfig"),Hn=c(),V=a("div"),b(so.$$.fragment),Ga=c(),O=a("p"),Wa=n("This is the configuration class to store the configuration of a "),Xo=a("a"),Ha=n("Blip2QFormerModel"),Ra=n(`. It is used to instantiate a
BLIP-2 Querying Transformer (Q-Former) model according to the specified arguments, defining the model architecture.
Instantiating a configuration with the defaults will yield a similar configuration to that of the BLIP-2
`),io=a("a"),Ua=n("Salesforce/blip2-opt-2.7b"),Ja=n(` architecture. Configuration objects
inherit from `),Yo=a("a"),Ka=n("PretrainedConfig"),Xa=n(` and can be used to control the model outputs. Read the documentation from
`),Zo=a("a"),Ya=n("PretrainedConfig"),Za=n(" for more information."),es=c(),le=a("p"),os=n("Note that "),et=a("a"),ts=n("Blip2QFormerModel"),ns=n(" is very similar to "),ot=a("a"),rs=n("BertLMHeadModel"),as=n(" with interleaved cross-attention."),ss=c(),b(Pe.$$.fragment),Rn=c(),de=a("h2"),Ee=a("a"),jt=a("span"),b(lo.$$.fragment),is=c(),Lt=a("span"),ls=n("Blip2Processor"),Un=c(),j=a("div"),b(co.$$.fragment),ds=c(),At=a("p"),cs=n("Constructs a BLIP-2 processor which wraps a BLIP image processor and an OPT/T5 tokenizer into a single processor."),ps=c(),L=a("p"),tt=a("a"),fs=n("BlipProcessor"),ms=n(" offers all the functionalities of "),nt=a("a"),hs=n("BlipImageProcessor"),gs=n(" and "),rt=a("a"),us=n("AutoTokenizer"),_s=n(`. See the docstring
of `),Mt=a("code"),vs=n("__call__()"),bs=n(" and "),at=a("a"),$s=n("decode()"),Bs=n(" for more information."),ws=c(),Te=a("div"),b(po.$$.fragment),ys=c(),fo=a("p"),Cs=n("This method forwards all its arguments to PreTrainedTokenizer\u2019s "),st=a("a"),ks=n("batch_decode()"),Ps=n(`. Please
refer to the docstring of this method for more information.`),Es=c(),xe=a("div"),b(mo.$$.fragment),Ts=c(),ho=a("p"),xs=n("This method forwards all its arguments to PreTrainedTokenizer\u2019s "),it=a("a"),Fs=n("decode()"),zs=n(`. Please refer
to the docstring of this method for more information.`),Jn=c(),ce=a("h2"),Fe=a("a"),Qt=a("span"),b(go.$$.fragment),Is=c(),Vt=a("span"),qs=n("Blip2VisionModel"),Kn=c(),pe=a("div"),b(uo.$$.fragment),js=c(),U=a("div"),b(_o.$$.fragment),Ls=c(),fe=a("p"),As=n("The "),lt=a("a"),Ms=n("Blip2VisionModel"),Qs=n(" forward method, overrides the "),Ot=a("code"),Vs=n("__call__"),Os=n(" special method."),Ss=c(),b(ze.$$.fragment),Xn=c(),me=a("h2"),Ie=a("a"),St=a("span"),b(vo.$$.fragment),Ds=c(),Dt=a("span"),Ns=n("Blip2QFormerModel"),Yn=c(),N=a("div"),b(bo.$$.fragment),Gs=c(),Nt=a("p"),Ws=n("Querying Transformer (Q-Former), used in BLIP-2."),Hs=c(),J=a("div"),b($o.$$.fragment),Rs=c(),T=a("p"),Us=n("encoder_hidden_states  ("),Gt=a("code"),Js=n("torch.FloatTensor"),Ks=n(" of shape "),Wt=a("code"),Xs=n("(batch_size, sequence_length, hidden_size)"),Ys=n(", "),Ht=a("code"),Zs=n("optional"),ei=n(`):
Sequence of hidden-states at the output of the last layer of the encoder. Used in the cross-attention if
the model is configured as a decoder.
encoder_attention_mask (`),Rt=a("code"),oi=n("torch.FloatTensor"),ti=n(" of shape "),Ut=a("code"),ni=n("(batch_size, sequence_length)"),ri=n(", "),Jt=a("code"),ai=n("optional"),si=n(`):
Mask to avoid performing attention on the padding token indices of the encoder input. This mask is used in
the cross-attention if the model is configured as a decoder. Mask values selected in `),Kt=a("code"),ii=n("[0, 1]"),li=n(":"),di=c(),Bo=a("ul"),wo=a("li"),ci=n("1 for tokens that are "),Xt=a("strong"),pi=n("not masked"),fi=n(","),mi=c(),k=a("li"),hi=n("0 for tokens that are "),Yt=a("strong"),gi=n("masked"),ui=n(`.
past_key_values (`),Zt=a("code"),_i=n("tuple(tuple(torch.FloatTensor))"),vi=n(" of length "),en=a("code"),bi=n("config.n_layers"),$i=n(` with each tuple having 4 tensors of:
shape `),on=a("code"),Bi=n("(batch_size, num_heads, sequence_length - 1, embed_size_per_head)"),wi=n(`): Contains precomputed key and
value hidden states of the attention blocks. Can be used to speed up decoding. If `),tn=a("code"),yi=n("past_key_values"),Ci=n(` are
used, the user can optionally input only the last `),nn=a("code"),ki=n("decoder_input_ids"),Pi=n(` (those that don\u2019t have their past key
value states given to this model) of shape `),rn=a("code"),Ei=n("(batch_size, 1)"),Ti=n(" instead of all "),an=a("code"),xi=n("decoder_input_ids"),Fi=n(` of shape
`),sn=a("code"),zi=n("(batch_size, sequence_length)"),Ii=n(`.
use_cache (`),ln=a("code"),qi=n("bool"),ji=n(", "),dn=a("code"),Li=n("optional"),Ai=n(`):
If set to `),cn=a("code"),Mi=n("True"),Qi=n(", "),pn=a("code"),Vi=n("past_key_values"),Oi=n(` key value states are returned and can be used to speed up decoding (see
`),fn=a("code"),Si=n("past_key_values"),Di=n(")."),Zn=c(),he=a("h2"),qe=a("a"),mn=a("span"),b(yo.$$.fragment),Ni=c(),hn=a("span"),Gi=n("Blip2ForConditionalGeneration"),er=c(),x=a("div"),b(Co.$$.fragment),Wi=c(),gn=a("p"),Hi=n(`BLIP-2 Model for generating text given an image and an optional text prompt. The model consists of a vision
encoder, Querying Transformer (Q-Former) and a language model.`),Ri=c(),ko=a("p"),Ui=n("One can optionally pass "),un=a("code"),Ji=n("input_ids"),Ki=n(` to the model, which serve as a text prompt, to make the language model continue
the prompt. Otherwise, the language model starts generating text from the [BOS] (beginning-of-sequence) token.`),Xi=c(),Po=a("p"),Yi=n("This model inherits from "),dt=a("a"),Zi=n("PreTrainedModel"),el=n(`. Check the superclass documentation for the generic methods the
library implements for all its model (such as downloading or saving, resizing the input embeddings, pruning heads
etc.)`),ol=c(),Eo=a("p"),tl=n("This model is also a PyTorch "),To=a("a"),nl=n("torch.nn.Module"),rl=n(` subclass.
Use it as a regular PyTorch Module and refer to the PyTorch documentation for all matter related to general usage
and behavior.`),al=c(),z=a("div"),b(xo.$$.fragment),sl=c(),ge=a("p"),il=n("The "),ct=a("a"),ll=n("Blip2ForConditionalGeneration"),dl=n(" forward method, overrides the "),_n=a("code"),cl=n("__call__"),pl=n(" special method."),fl=c(),b(je.$$.fragment),ml=c(),vn=a("p"),hl=n("Examples:"),gl=c(),b(Le.$$.fragment),ul=c(),b(Ae.$$.fragment),_l=c(),Me=a("div"),b(Fo.$$.fragment),vl=c(),zo=a("p"),bl=n("Overrides "),bn=a("code"),$l=n("generate"),Bl=n(" function to be able to use the model as a conditional generator."),this.h()},l(o){const f=_c('[data-svelte="svelte-1phssyn"]',document.head);h=s(f,"META",{name:!0,content:!0}),f.forEach(t),P=p(o),_=s(o,"H1",{class:!0});var Io=i(_);g=s(Io,"A",{id:!0,class:!0,href:!0});var $n=i(g);v=s($n,"SPAN",{});var Bn=i(v);$(d.$$.fragment,Bn),Bn.forEach(t),$n.forEach(t),u=p(Io),D=s(Io,"SPAN",{});var wn=i(D);Tr=r(wn,"BLIP-2"),wn.forEach(t),Io.forEach(t),Tn=p(o),ee=s(o,"H2",{class:!0});var qo=i(ee);ue=s(qo,"A",{id:!0,class:!0,href:!0});var yn=i(ue);wt=s(yn,"SPAN",{});var Cn=i(wt);$(Oe.$$.fragment,Cn),Cn.forEach(t),yn.forEach(t),xr=p(qo),yt=s(qo,"SPAN",{});var Cl=i(yt);Fr=r(Cl,"Overview"),Cl.forEach(t),qo.forEach(t),xn=p(o),W=s(o,"P",{});var pt=i(W);zr=r(pt,"The BLIP-2 model was proposed in "),Se=s(pt,"A",{href:!0,rel:!0});var kl=i(Se);Ir=r(kl,"BLIP-2: Bootstrapping Language-Image Pre-training with Frozen Image Encoders and Large Language Models"),kl.forEach(t),qr=r(pt,` by
Junnan Li, Dongxu Li, Silvio Savarese, Steven Hoi. BLIP-2 leverages frozen pre-trained image encoders and large language models (LLMs) by training a lightweight, 12-layer Transformer
encoder in between them, achieving state-of-the-art performance on various vision-language tasks. Most notably, BLIP-2 improves upon `),De=s(pt,"A",{href:!0,rel:!0});var Pl=i(De);jr=r(Pl,"Flamingo"),Pl.forEach(t),Lr=r(pt,`, an 80 billion parameter model, by 8.7%
on zero-shot VQAv2 with 54x fewer trainable parameters.`),pt.forEach(t),Fn=p(o),Lo=s(o,"P",{});var El=i(Lo);Ar=r(El,"The abstract from the paper is the following:"),El.forEach(t),zn=p(o),Ao=s(o,"P",{});var Tl=i(Ao);Ct=s(Tl,"EM",{});var xl=i(Ct);Mr=r(xl,"The cost of vision-and-language pre-training has become increasingly prohibitive due to end-to-end training of large-scale models. This paper proposes BLIP-2, a generic and efficient pre-training strategy that bootstraps vision-language pre-training from off-the-shelf frozen pre-trained image encoders and frozen large language models. BLIP-2 bridges the modality gap with a lightweight Querying Transformer, which is pre-trained in two stages. The first stage bootstraps vision-language representation learning from a frozen image encoder. The second stage bootstraps vision-to-language generative learning from a frozen language model. BLIP-2 achieves state-of-the-art performance on various vision-language tasks, despite having significantly fewer trainable parameters than existing methods. For example, our model outperforms Flamingo80B by 8.7% on zero-shot VQAv2 with 54x fewer trainable parameters. We also demonstrate the model\u2019s emerging capabilities of zero-shot image-to-text generation that can follow natural language instructions."),xl.forEach(t),Tl.forEach(t),In=p(o),Mo=s(o,"P",{});var Fl=i(Mo);Qr=r(Fl,"Tips:"),Fl.forEach(t),qn=p(o),_e=s(o,"UL",{});var tr=i(_e);Ne=s(tr,"LI",{});var nr=i(Ne);Vr=r(nr,"BLIP-2 can be used for conditional text generation given an image and an optional text prompt. At inference time, it\u2019s recommended to use the "),kt=s(nr,"CODE",{});var zl=i(kt);Or=r(zl,"generate"),zl.forEach(t),Sr=r(nr," method."),nr.forEach(t),Dr=p(tr),Ge=s(tr,"LI",{});var rr=i(Ge);Nr=r(rr,"One can use "),Qo=s(rr,"A",{href:!0});var Il=i(Qo);Gr=r(Il,"Blip2Processor"),Il.forEach(t),Wr=r(rr," to prepare images for the model, and decode the predicted tokens ID\u2019s back to text."),rr.forEach(t),tr.forEach(t),jn=p(o),ve=s(o,"IMG",{src:!0,alt:!0,width:!0}),Ln=p(o),We=s(o,"SMALL",{});var wl=i(We);Hr=r(wl,"BLIP-2 architecture. Taken from the "),Vo=s(wl,"A",{href:!0});var ql=i(Vo);Rr=r(ql,"original paper."),ql.forEach(t),wl.forEach(t),An=p(o),H=s(o,"P",{});var ft=i(H);Ur=r(ft,"This model was contributed by "),He=s(ft,"A",{href:!0,rel:!0});var jl=i(He);Jr=r(jl,"nielsr"),jl.forEach(t),Kr=r(ft,`.
The original code can be found `),Re=s(ft,"A",{href:!0,rel:!0});var Ll=i(Re);Xr=r(Ll,"here"),Ll.forEach(t),Yr=r(ft,"."),ft.forEach(t),Mn=p(o),oe=s(o,"H2",{class:!0});var ar=i(oe);be=s(ar,"A",{id:!0,class:!0,href:!0});var Al=i(be);Pt=s(Al,"SPAN",{});var Ml=i(Pt);$(Ue.$$.fragment,Ml),Ml.forEach(t),Al.forEach(t),Zr=p(ar),Et=s(ar,"SPAN",{});var Ql=i(Et);ea=r(Ql,"Resources"),Ql.forEach(t),ar.forEach(t),Qn=p(o),Oo=s(o,"P",{});var Vl=i(Oo);oa=r(Vl,"A list of official Hugging Face and community (indicated by \u{1F30E}) resources to help you get started with BLIP-2."),Vl.forEach(t),Vn=p(o),So=s(o,"UL",{});var Ol=i(So);Je=s(Ol,"LI",{});var sr=i(Je);ta=r(sr,"Demo notebooks for BLIP-2 for image captioning, visual question answering (VQA) and chat-like conversations can be found "),Ke=s(sr,"A",{href:!0,rel:!0});var Sl=i(Ke);na=r(Sl,"here"),Sl.forEach(t),ra=r(sr,"."),sr.forEach(t),Ol.forEach(t),On=p(o),Do=s(o,"P",{});var Dl=i(Do);aa=r(Dl,"If you\u2019re interested in submitting a resource to be included here, please feel free to open a Pull Request and we\u2019ll review it! The resource should ideally demonstrate something new instead of duplicating an existing resource."),Dl.forEach(t),Sn=p(o),te=s(o,"H2",{class:!0});var ir=i(te);$e=s(ir,"A",{id:!0,class:!0,href:!0});var Nl=i($e);Tt=s(Nl,"SPAN",{});var Gl=i(Tt);$(Xe.$$.fragment,Gl),Gl.forEach(t),Nl.forEach(t),sa=p(ir),xt=s(ir,"SPAN",{});var Wl=i(xt);ia=r(Wl,"Blip2Config"),Wl.forEach(t),ir.forEach(t),Dn=p(o),q=s(o,"DIV",{class:!0});var K=i(q);$(Ye.$$.fragment,K),la=p(K),R=s(K,"P",{});var jo=i(R);No=s(jo,"A",{href:!0});var Hl=i(No);da=r(Hl,"Blip2Config"),Hl.forEach(t),ca=r(jo," is the configuration class to store the configuration of a "),Go=s(jo,"A",{href:!0});var Rl=i(Go);pa=r(Rl,"Blip2ForConditionalGeneration"),Rl.forEach(t),fa=r(jo,`. It is
used to instantiate a BLIP-2 model according to the specified arguments, defining the vision model, Q-Former model
and language model configs. Instantiating a configuration with the defaults will yield a similar configuration to
that of the BLIP-2 `),Ze=s(jo,"A",{href:!0,rel:!0});var Ul=i(Ze);ma=r(Ul,"Salesforce/blip2-opt-2.7b"),Ul.forEach(t),ha=r(jo," architecture."),jo.forEach(t),ga=p(K),ne=s(K,"P",{});var mt=i(ne);ua=r(mt,"Configuration objects inherit from "),Wo=s(mt,"A",{href:!0});var Jl=i(Wo);_a=r(Jl,"PretrainedConfig"),Jl.forEach(t),va=r(mt,` and can be used to control the model outputs. Read the
documentation from `),Ho=s(mt,"A",{href:!0});var Kl=i(Ho);ba=r(Kl,"PretrainedConfig"),Kl.forEach(t),$a=r(mt," for more information."),mt.forEach(t),Ba=p(K),$(Be.$$.fragment,K),wa=p(K),we=s(K,"DIV",{class:!0});var lr=i(we);$(eo.$$.fragment,lr),ya=p(lr),oo=s(lr,"P",{});var dr=i(oo);Ca=r(dr,"Instantiate a "),Ro=s(dr,"A",{href:!0});var Xl=i(Ro);ka=r(Xl,"Blip2Config"),Xl.forEach(t),Pa=r(dr,` (or a derived class) from a BLIP-2 vision model, Q-Former and language model
configurations.`),dr.forEach(t),lr.forEach(t),K.forEach(t),Nn=p(o),re=s(o,"H2",{class:!0});var cr=i(re);ye=s(cr,"A",{id:!0,class:!0,href:!0});var Yl=i(ye);Ft=s(Yl,"SPAN",{});var Zl=i(Ft);$(to.$$.fragment,Zl),Zl.forEach(t),Yl.forEach(t),Ea=p(cr),zt=s(cr,"SPAN",{});var ed=i(zt);Ta=r(ed,"Blip2VisionConfig"),ed.forEach(t),cr.forEach(t),Gn=p(o),Q=s(o,"DIV",{class:!0});var Qe=i(Q);$(no.$$.fragment,Qe),xa=p(Qe),ae=s(Qe,"P",{});var ht=i(ae);Fa=r(ht,"This is the configuration class to store the configuration of a "),Uo=s(ht,"A",{href:!0});var od=i(Uo);za=r(od,"Blip2VisionModel"),od.forEach(t),Ia=r(ht,`. It is used to instantiate a
BLIP-2 vision encoder according to the specified arguments, defining the model architecture. Instantiating a
configuration defaults will yield a similar configuration to that of the BLIP-2
`),ro=s(ht,"A",{href:!0,rel:!0});var td=i(ro);qa=r(td,"Salesforce/blip2-opt-2.7b"),td.forEach(t),ja=r(ht," architecture."),ht.forEach(t),La=p(Qe),se=s(Qe,"P",{});var gt=i(se);Aa=r(gt,"Configuration objects inherit from "),Jo=s(gt,"A",{href:!0});var nd=i(Jo);Ma=r(nd,"PretrainedConfig"),nd.forEach(t),Qa=r(gt,` and can be used to control the model outputs. Read the
documentation from `),Ko=s(gt,"A",{href:!0});var rd=i(Ko);Va=r(rd,"PretrainedConfig"),rd.forEach(t),Oa=r(gt," for more information."),gt.forEach(t),Sa=p(Qe),$(Ce.$$.fragment,Qe),Qe.forEach(t),Wn=p(o),ie=s(o,"H2",{class:!0});var pr=i(ie);ke=s(pr,"A",{id:!0,class:!0,href:!0});var ad=i(ke);It=s(ad,"SPAN",{});var sd=i(It);$(ao.$$.fragment,sd),sd.forEach(t),ad.forEach(t),Da=p(pr),qt=s(pr,"SPAN",{});var id=i(qt);Na=r(id,"Blip2QFormerConfig"),id.forEach(t),pr.forEach(t),Hn=p(o),V=s(o,"DIV",{class:!0});var Ve=i(V);$(so.$$.fragment,Ve),Ga=p(Ve),O=s(Ve,"P",{});var X=i(O);Wa=r(X,"This is the configuration class to store the configuration of a "),Xo=s(X,"A",{href:!0});var ld=i(Xo);Ha=r(ld,"Blip2QFormerModel"),ld.forEach(t),Ra=r(X,`. It is used to instantiate a
BLIP-2 Querying Transformer (Q-Former) model according to the specified arguments, defining the model architecture.
Instantiating a configuration with the defaults will yield a similar configuration to that of the BLIP-2
`),io=s(X,"A",{href:!0,rel:!0});var dd=i(io);Ua=r(dd,"Salesforce/blip2-opt-2.7b"),dd.forEach(t),Ja=r(X,` architecture. Configuration objects
inherit from `),Yo=s(X,"A",{href:!0});var cd=i(Yo);Ka=r(cd,"PretrainedConfig"),cd.forEach(t),Xa=r(X,` and can be used to control the model outputs. Read the documentation from
`),Zo=s(X,"A",{href:!0});var pd=i(Zo);Ya=r(pd,"PretrainedConfig"),pd.forEach(t),Za=r(X," for more information."),X.forEach(t),es=p(Ve),le=s(Ve,"P",{});var ut=i(le);os=r(ut,"Note that "),et=s(ut,"A",{href:!0});var fd=i(et);ts=r(fd,"Blip2QFormerModel"),fd.forEach(t),ns=r(ut," is very similar to "),ot=s(ut,"A",{href:!0});var md=i(ot);rs=r(md,"BertLMHeadModel"),md.forEach(t),as=r(ut," with interleaved cross-attention."),ut.forEach(t),ss=p(Ve),$(Pe.$$.fragment,Ve),Ve.forEach(t),Rn=p(o),de=s(o,"H2",{class:!0});var fr=i(de);Ee=s(fr,"A",{id:!0,class:!0,href:!0});var hd=i(Ee);jt=s(hd,"SPAN",{});var gd=i(jt);$(lo.$$.fragment,gd),gd.forEach(t),hd.forEach(t),is=p(fr),Lt=s(fr,"SPAN",{});var ud=i(Lt);ls=r(ud,"Blip2Processor"),ud.forEach(t),fr.forEach(t),Un=p(o),j=s(o,"DIV",{class:!0});var Y=i(j);$(co.$$.fragment,Y),ds=p(Y),At=s(Y,"P",{});var _d=i(At);cs=r(_d,"Constructs a BLIP-2 processor which wraps a BLIP image processor and an OPT/T5 tokenizer into a single processor."),_d.forEach(t),ps=p(Y),L=s(Y,"P",{});var G=i(L);tt=s(G,"A",{href:!0});var vd=i(tt);fs=r(vd,"BlipProcessor"),vd.forEach(t),ms=r(G," offers all the functionalities of "),nt=s(G,"A",{href:!0});var bd=i(nt);hs=r(bd,"BlipImageProcessor"),bd.forEach(t),gs=r(G," and "),rt=s(G,"A",{href:!0});var $d=i(rt);us=r($d,"AutoTokenizer"),$d.forEach(t),_s=r(G,`. See the docstring
of `),Mt=s(G,"CODE",{});var Bd=i(Mt);vs=r(Bd,"__call__()"),Bd.forEach(t),bs=r(G," and "),at=s(G,"A",{href:!0});var wd=i(at);$s=r(wd,"decode()"),wd.forEach(t),Bs=r(G," for more information."),G.forEach(t),ws=p(Y),Te=s(Y,"DIV",{class:!0});var mr=i(Te);$(po.$$.fragment,mr),ys=p(mr),fo=s(mr,"P",{});var hr=i(fo);Cs=r(hr,"This method forwards all its arguments to PreTrainedTokenizer\u2019s "),st=s(hr,"A",{href:!0});var yd=i(st);ks=r(yd,"batch_decode()"),yd.forEach(t),Ps=r(hr,`. Please
refer to the docstring of this method for more information.`),hr.forEach(t),mr.forEach(t),Es=p(Y),xe=s(Y,"DIV",{class:!0});var gr=i(xe);$(mo.$$.fragment,gr),Ts=p(gr),ho=s(gr,"P",{});var ur=i(ho);xs=r(ur,"This method forwards all its arguments to PreTrainedTokenizer\u2019s "),it=s(ur,"A",{href:!0});var Cd=i(it);Fs=r(Cd,"decode()"),Cd.forEach(t),zs=r(ur,`. Please refer
to the docstring of this method for more information.`),ur.forEach(t),gr.forEach(t),Y.forEach(t),Jn=p(o),ce=s(o,"H2",{class:!0});var _r=i(ce);Fe=s(_r,"A",{id:!0,class:!0,href:!0});var kd=i(Fe);Qt=s(kd,"SPAN",{});var Pd=i(Qt);$(go.$$.fragment,Pd),Pd.forEach(t),kd.forEach(t),Is=p(_r),Vt=s(_r,"SPAN",{});var Ed=i(Vt);qs=r(Ed,"Blip2VisionModel"),Ed.forEach(t),_r.forEach(t),Kn=p(o),pe=s(o,"DIV",{class:!0});var vr=i(pe);$(uo.$$.fragment,vr),js=p(vr),U=s(vr,"DIV",{class:!0});var _t=i(U);$(_o.$$.fragment,_t),Ls=p(_t),fe=s(_t,"P",{});var vt=i(fe);As=r(vt,"The "),lt=s(vt,"A",{href:!0});var Td=i(lt);Ms=r(Td,"Blip2VisionModel"),Td.forEach(t),Qs=r(vt," forward method, overrides the "),Ot=s(vt,"CODE",{});var xd=i(Ot);Vs=r(xd,"__call__"),xd.forEach(t),Os=r(vt," special method."),vt.forEach(t),Ss=p(_t),$(ze.$$.fragment,_t),_t.forEach(t),vr.forEach(t),Xn=p(o),me=s(o,"H2",{class:!0});var br=i(me);Ie=s(br,"A",{id:!0,class:!0,href:!0});var Fd=i(Ie);St=s(Fd,"SPAN",{});var zd=i(St);$(vo.$$.fragment,zd),zd.forEach(t),Fd.forEach(t),Ds=p(br),Dt=s(br,"SPAN",{});var Id=i(Dt);Ns=r(Id,"Blip2QFormerModel"),Id.forEach(t),br.forEach(t),Yn=p(o),N=s(o,"DIV",{class:!0});var bt=i(N);$(bo.$$.fragment,bt),Gs=p(bt),Nt=s(bt,"P",{});var qd=i(Nt);Ws=r(qd,"Querying Transformer (Q-Former), used in BLIP-2."),qd.forEach(t),Hs=p(bt),J=s(bt,"DIV",{class:!0});var $t=i(J);$($o.$$.fragment,$t),Rs=p($t),T=s($t,"P",{});var I=i(T);Us=r(I,"encoder_hidden_states  ("),Gt=s(I,"CODE",{});var jd=i(Gt);Js=r(jd,"torch.FloatTensor"),jd.forEach(t),Ks=r(I," of shape "),Wt=s(I,"CODE",{});var Ld=i(Wt);Xs=r(Ld,"(batch_size, sequence_length, hidden_size)"),Ld.forEach(t),Ys=r(I,", "),Ht=s(I,"CODE",{});var Ad=i(Ht);Zs=r(Ad,"optional"),Ad.forEach(t),ei=r(I,`):
Sequence of hidden-states at the output of the last layer of the encoder. Used in the cross-attention if
the model is configured as a decoder.
encoder_attention_mask (`),Rt=s(I,"CODE",{});var Md=i(Rt);oi=r(Md,"torch.FloatTensor"),Md.forEach(t),ti=r(I," of shape "),Ut=s(I,"CODE",{});var Qd=i(Ut);ni=r(Qd,"(batch_size, sequence_length)"),Qd.forEach(t),ri=r(I,", "),Jt=s(I,"CODE",{});var Vd=i(Jt);ai=r(Vd,"optional"),Vd.forEach(t),si=r(I,`):
Mask to avoid performing attention on the padding token indices of the encoder input. This mask is used in
the cross-attention if the model is configured as a decoder. Mask values selected in `),Kt=s(I,"CODE",{});var Od=i(Kt);ii=r(Od,"[0, 1]"),Od.forEach(t),li=r(I,":"),I.forEach(t),di=p($t),Bo=s($t,"UL",{});var $r=i(Bo);wo=s($r,"LI",{});var Br=i(wo);ci=r(Br,"1 for tokens that are "),Xt=s(Br,"STRONG",{});var Sd=i(Xt);pi=r(Sd,"not masked"),Sd.forEach(t),fi=r(Br,","),Br.forEach(t),mi=p($r),k=s($r,"LI",{});var E=i(k);hi=r(E,"0 for tokens that are "),Yt=s(E,"STRONG",{});var Dd=i(Yt);gi=r(Dd,"masked"),Dd.forEach(t),ui=r(E,`.
past_key_values (`),Zt=s(E,"CODE",{});var Nd=i(Zt);_i=r(Nd,"tuple(tuple(torch.FloatTensor))"),Nd.forEach(t),vi=r(E," of length "),en=s(E,"CODE",{});var Gd=i(en);bi=r(Gd,"config.n_layers"),Gd.forEach(t),$i=r(E,` with each tuple having 4 tensors of:
shape `),on=s(E,"CODE",{});var Wd=i(on);Bi=r(Wd,"(batch_size, num_heads, sequence_length - 1, embed_size_per_head)"),Wd.forEach(t),wi=r(E,`): Contains precomputed key and
value hidden states of the attention blocks. Can be used to speed up decoding. If `),tn=s(E,"CODE",{});var Hd=i(tn);yi=r(Hd,"past_key_values"),Hd.forEach(t),Ci=r(E,` are
used, the user can optionally input only the last `),nn=s(E,"CODE",{});var Rd=i(nn);ki=r(Rd,"decoder_input_ids"),Rd.forEach(t),Pi=r(E,` (those that don\u2019t have their past key
value states given to this model) of shape `),rn=s(E,"CODE",{});var Ud=i(rn);Ei=r(Ud,"(batch_size, 1)"),Ud.forEach(t),Ti=r(E," instead of all "),an=s(E,"CODE",{});var Jd=i(an);xi=r(Jd,"decoder_input_ids"),Jd.forEach(t),Fi=r(E,` of shape
`),sn=s(E,"CODE",{});var Kd=i(sn);zi=r(Kd,"(batch_size, sequence_length)"),Kd.forEach(t),Ii=r(E,`.
use_cache (`),ln=s(E,"CODE",{});var Xd=i(ln);qi=r(Xd,"bool"),Xd.forEach(t),ji=r(E,", "),dn=s(E,"CODE",{});var Yd=i(dn);Li=r(Yd,"optional"),Yd.forEach(t),Ai=r(E,`):
If set to `),cn=s(E,"CODE",{});var Zd=i(cn);Mi=r(Zd,"True"),Zd.forEach(t),Qi=r(E,", "),pn=s(E,"CODE",{});var ec=i(pn);Vi=r(ec,"past_key_values"),ec.forEach(t),Oi=r(E,` key value states are returned and can be used to speed up decoding (see
`),fn=s(E,"CODE",{});var oc=i(fn);Si=r(oc,"past_key_values"),oc.forEach(t),Di=r(E,")."),E.forEach(t),$r.forEach(t),$t.forEach(t),bt.forEach(t),Zn=p(o),he=s(o,"H2",{class:!0});var wr=i(he);qe=s(wr,"A",{id:!0,class:!0,href:!0});var tc=i(qe);mn=s(tc,"SPAN",{});var nc=i(mn);$(yo.$$.fragment,nc),nc.forEach(t),tc.forEach(t),Ni=p(wr),hn=s(wr,"SPAN",{});var rc=i(hn);Gi=r(rc,"Blip2ForConditionalGeneration"),rc.forEach(t),wr.forEach(t),er=p(o),x=s(o,"DIV",{class:!0});var A=i(x);$(Co.$$.fragment,A),Wi=p(A),gn=s(A,"P",{});var ac=i(gn);Hi=r(ac,`BLIP-2 Model for generating text given an image and an optional text prompt. The model consists of a vision
encoder, Querying Transformer (Q-Former) and a language model.`),ac.forEach(t),Ri=p(A),ko=s(A,"P",{});var yr=i(ko);Ui=r(yr,"One can optionally pass "),un=s(yr,"CODE",{});var sc=i(un);Ji=r(sc,"input_ids"),sc.forEach(t),Ki=r(yr,` to the model, which serve as a text prompt, to make the language model continue
the prompt. Otherwise, the language model starts generating text from the [BOS] (beginning-of-sequence) token.`),yr.forEach(t),Xi=p(A),Po=s(A,"P",{});var Cr=i(Po);Yi=r(Cr,"This model inherits from "),dt=s(Cr,"A",{href:!0});var ic=i(dt);Zi=r(ic,"PreTrainedModel"),ic.forEach(t),el=r(Cr,`. Check the superclass documentation for the generic methods the
library implements for all its model (such as downloading or saving, resizing the input embeddings, pruning heads
etc.)`),Cr.forEach(t),ol=p(A),Eo=s(A,"P",{});var kr=i(Eo);tl=r(kr,"This model is also a PyTorch "),To=s(kr,"A",{href:!0,rel:!0});var lc=i(To);nl=r(lc,"torch.nn.Module"),lc.forEach(t),rl=r(kr,` subclass.
Use it as a regular PyTorch Module and refer to the PyTorch documentation for all matter related to general usage
and behavior.`),kr.forEach(t),al=p(A),z=s(A,"DIV",{class:!0});var S=i(z);$(xo.$$.fragment,S),sl=p(S),ge=s(S,"P",{});var Bt=i(ge);il=r(Bt,"The "),ct=s(Bt,"A",{href:!0});var dc=i(ct);ll=r(dc,"Blip2ForConditionalGeneration"),dc.forEach(t),dl=r(Bt," forward method, overrides the "),_n=s(Bt,"CODE",{});var cc=i(_n);cl=r(cc,"__call__"),cc.forEach(t),pl=r(Bt," special method."),Bt.forEach(t),fl=p(S),$(je.$$.fragment,S),ml=p(S),vn=s(S,"P",{});var pc=i(vn);hl=r(pc,"Examples:"),pc.forEach(t),gl=p(S),$(Le.$$.fragment,S),ul=p(S),$(Ae.$$.fragment,S),S.forEach(t),_l=p(A),Me=s(A,"DIV",{class:!0});var Pr=i(Me);$(Fo.$$.fragment,Pr),vl=p(Pr),zo=s(Pr,"P",{});var Er=i(zo);bl=r(Er,"Overrides "),bn=s(Er,"CODE",{});var fc=i(bn);$l=r(fc,"generate"),fc.forEach(t),Bl=r(Er," function to be able to use the model as a conditional generator."),Er.forEach(t),Pr.forEach(t),A.forEach(t),this.h()},h(){l(h,"name","hf:doc:metadata"),l(h,"content",JSON.stringify(Tc)),l(g,"id","blip2"),l(g,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),l(g,"href","#blip2"),l(_,"class","relative group"),l(ue,"id","overview"),l(ue,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),l(ue,"href","#overview"),l(ee,"class","relative group"),l(Se,"href","https://arxiv.org/abs/2301.12597"),l(Se,"rel","nofollow"),l(De,"href","https://arxiv.org/abs/2204.14198"),l(De,"rel","nofollow"),l(Qo,"href","/docs/transformers/main/en/model_doc/blip-2#transformers.Blip2Processor"),vc(ve.src,yl="https://huggingface.co/datasets/huggingface/documentation-images/resolve/main/transformers/model_doc/blip2_architecture.jpg")||l(ve,"src",yl),l(ve,"alt","drawing"),l(ve,"width","600"),l(Vo,"href","https://arxiv.org/abs/2301.12597"),l(He,"href","https://huggingface.co/nielsr"),l(He,"rel","nofollow"),l(Re,"href","https://github.com/salesforce/LAVIS/tree/5ee63d688ba4cebff63acee04adaef2dee9af207"),l(Re,"rel","nofollow"),l(be,"id","resources"),l(be,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),l(be,"href","#resources"),l(oe,"class","relative group"),l(Ke,"href","https://github.com/NielsRogge/Transformers-Tutorials/tree/master/BLIP-2"),l(Ke,"rel","nofollow"),l($e,"id","transformers.Blip2Config"),l($e,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),l($e,"href","#transformers.Blip2Config"),l(te,"class","relative group"),l(No,"href","/docs/transformers/main/en/model_doc/blip-2#transformers.Blip2Config"),l(Go,"href","/docs/transformers/main/en/model_doc/blip-2#transformers.Blip2ForConditionalGeneration"),l(Ze,"href","https://huggingface.co/Salesforce/blip2-opt-2.7b"),l(Ze,"rel","nofollow"),l(Wo,"href","/docs/transformers/main/en/main_classes/configuration#transformers.PretrainedConfig"),l(Ho,"href","/docs/transformers/main/en/main_classes/configuration#transformers.PretrainedConfig"),l(Ro,"href","/docs/transformers/main/en/model_doc/blip-2#transformers.Blip2Config"),l(we,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),l(q,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),l(ye,"id","transformers.Blip2VisionConfig"),l(ye,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),l(ye,"href","#transformers.Blip2VisionConfig"),l(re,"class","relative group"),l(Uo,"href","/docs/transformers/main/en/model_doc/blip-2#transformers.Blip2VisionModel"),l(ro,"href","https://huggingface.co/Salesforce/blip2-opt-2.7b"),l(ro,"rel","nofollow"),l(Jo,"href","/docs/transformers/main/en/main_classes/configuration#transformers.PretrainedConfig"),l(Ko,"href","/docs/transformers/main/en/main_classes/configuration#transformers.PretrainedConfig"),l(Q,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),l(ke,"id","transformers.Blip2QFormerConfig"),l(ke,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),l(ke,"href","#transformers.Blip2QFormerConfig"),l(ie,"class","relative group"),l(Xo,"href","/docs/transformers/main/en/model_doc/blip-2#transformers.Blip2QFormerModel"),l(io,"href","https://huggingface.co/Salesforce/blip2-opt-2.7b"),l(io,"rel","nofollow"),l(Yo,"href","/docs/transformers/main/en/main_classes/configuration#transformers.PretrainedConfig"),l(Zo,"href","/docs/transformers/main/en/main_classes/configuration#transformers.PretrainedConfig"),l(et,"href","/docs/transformers/main/en/model_doc/blip-2#transformers.Blip2QFormerModel"),l(ot,"href","/docs/transformers/main/en/model_doc/bert#transformers.BertLMHeadModel"),l(V,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),l(Ee,"id","transformers.Blip2Processor"),l(Ee,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),l(Ee,"href","#transformers.Blip2Processor"),l(de,"class","relative group"),l(tt,"href","/docs/transformers/main/en/model_doc/blip#transformers.BlipProcessor"),l(nt,"href","/docs/transformers/main/en/model_doc/blip#transformers.BlipImageProcessor"),l(rt,"href","/docs/transformers/main/en/model_doc/auto#transformers.AutoTokenizer"),l(at,"href","/docs/transformers/main/en/model_doc/blip#transformers.BlipProcessor.decode"),l(st,"href","/docs/transformers/main/en/internal/tokenization_utils#transformers.PreTrainedTokenizerBase.batch_decode"),l(Te,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),l(it,"href","/docs/transformers/main/en/internal/tokenization_utils#transformers.PreTrainedTokenizerBase.decode"),l(xe,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),l(j,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),l(Fe,"id","transformers.Blip2VisionModel"),l(Fe,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),l(Fe,"href","#transformers.Blip2VisionModel"),l(ce,"class","relative group"),l(lt,"href","/docs/transformers/main/en/model_doc/blip-2#transformers.Blip2VisionModel"),l(U,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),l(pe,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),l(Ie,"id","transformers.Blip2QFormerModel"),l(Ie,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),l(Ie,"href","#transformers.Blip2QFormerModel"),l(me,"class","relative group"),l(J,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),l(N,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),l(qe,"id","transformers.Blip2ForConditionalGeneration"),l(qe,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),l(qe,"href","#transformers.Blip2ForConditionalGeneration"),l(he,"class","relative group"),l(dt,"href","/docs/transformers/main/en/main_classes/model#transformers.PreTrainedModel"),l(To,"href","https://pytorch.org/docs/stable/nn.html#torch.nn.Module"),l(To,"rel","nofollow"),l(ct,"href","/docs/transformers/main/en/model_doc/blip-2#transformers.Blip2ForConditionalGeneration"),l(z,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),l(Me,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),l(x,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8")},m(o,f){e(document.head,h),m(o,P,f),m(o,_,f),e(_,g),e(g,v),B(d,v,null),e(_,u),e(_,D),e(D,Tr),m(o,Tn,f),m(o,ee,f),e(ee,ue),e(ue,wt),B(Oe,wt,null),e(ee,xr),e(ee,yt),e(yt,Fr),m(o,xn,f),m(o,W,f),e(W,zr),e(W,Se),e(Se,Ir),e(W,qr),e(W,De),e(De,jr),e(W,Lr),m(o,Fn,f),m(o,Lo,f),e(Lo,Ar),m(o,zn,f),m(o,Ao,f),e(Ao,Ct),e(Ct,Mr),m(o,In,f),m(o,Mo,f),e(Mo,Qr),m(o,qn,f),m(o,_e,f),e(_e,Ne),e(Ne,Vr),e(Ne,kt),e(kt,Or),e(Ne,Sr),e(_e,Dr),e(_e,Ge),e(Ge,Nr),e(Ge,Qo),e(Qo,Gr),e(Ge,Wr),m(o,jn,f),m(o,ve,f),m(o,Ln,f),m(o,We,f),e(We,Hr),e(We,Vo),e(Vo,Rr),m(o,An,f),m(o,H,f),e(H,Ur),e(H,He),e(He,Jr),e(H,Kr),e(H,Re),e(Re,Xr),e(H,Yr),m(o,Mn,f),m(o,oe,f),e(oe,be),e(be,Pt),B(Ue,Pt,null),e(oe,Zr),e(oe,Et),e(Et,ea),m(o,Qn,f),m(o,Oo,f),e(Oo,oa),m(o,Vn,f),m(o,So,f),e(So,Je),e(Je,ta),e(Je,Ke),e(Ke,na),e(Je,ra),m(o,On,f),m(o,Do,f),e(Do,aa),m(o,Sn,f),m(o,te,f),e(te,$e),e($e,Tt),B(Xe,Tt,null),e(te,sa),e(te,xt),e(xt,ia),m(o,Dn,f),m(o,q,f),B(Ye,q,null),e(q,la),e(q,R),e(R,No),e(No,da),e(R,ca),e(R,Go),e(Go,pa),e(R,fa),e(R,Ze),e(Ze,ma),e(R,ha),e(q,ga),e(q,ne),e(ne,ua),e(ne,Wo),e(Wo,_a),e(ne,va),e(ne,Ho),e(Ho,ba),e(ne,$a),e(q,Ba),B(Be,q,null),e(q,wa),e(q,we),B(eo,we,null),e(we,ya),e(we,oo),e(oo,Ca),e(oo,Ro),e(Ro,ka),e(oo,Pa),m(o,Nn,f),m(o,re,f),e(re,ye),e(ye,Ft),B(to,Ft,null),e(re,Ea),e(re,zt),e(zt,Ta),m(o,Gn,f),m(o,Q,f),B(no,Q,null),e(Q,xa),e(Q,ae),e(ae,Fa),e(ae,Uo),e(Uo,za),e(ae,Ia),e(ae,ro),e(ro,qa),e(ae,ja),e(Q,La),e(Q,se),e(se,Aa),e(se,Jo),e(Jo,Ma),e(se,Qa),e(se,Ko),e(Ko,Va),e(se,Oa),e(Q,Sa),B(Ce,Q,null),m(o,Wn,f),m(o,ie,f),e(ie,ke),e(ke,It),B(ao,It,null),e(ie,Da),e(ie,qt),e(qt,Na),m(o,Hn,f),m(o,V,f),B(so,V,null),e(V,Ga),e(V,O),e(O,Wa),e(O,Xo),e(Xo,Ha),e(O,Ra),e(O,io),e(io,Ua),e(O,Ja),e(O,Yo),e(Yo,Ka),e(O,Xa),e(O,Zo),e(Zo,Ya),e(O,Za),e(V,es),e(V,le),e(le,os),e(le,et),e(et,ts),e(le,ns),e(le,ot),e(ot,rs),e(le,as),e(V,ss),B(Pe,V,null),m(o,Rn,f),m(o,de,f),e(de,Ee),e(Ee,jt),B(lo,jt,null),e(de,is),e(de,Lt),e(Lt,ls),m(o,Un,f),m(o,j,f),B(co,j,null),e(j,ds),e(j,At),e(At,cs),e(j,ps),e(j,L),e(L,tt),e(tt,fs),e(L,ms),e(L,nt),e(nt,hs),e(L,gs),e(L,rt),e(rt,us),e(L,_s),e(L,Mt),e(Mt,vs),e(L,bs),e(L,at),e(at,$s),e(L,Bs),e(j,ws),e(j,Te),B(po,Te,null),e(Te,ys),e(Te,fo),e(fo,Cs),e(fo,st),e(st,ks),e(fo,Ps),e(j,Es),e(j,xe),B(mo,xe,null),e(xe,Ts),e(xe,ho),e(ho,xs),e(ho,it),e(it,Fs),e(ho,zs),m(o,Jn,f),m(o,ce,f),e(ce,Fe),e(Fe,Qt),B(go,Qt,null),e(ce,Is),e(ce,Vt),e(Vt,qs),m(o,Kn,f),m(o,pe,f),B(uo,pe,null),e(pe,js),e(pe,U),B(_o,U,null),e(U,Ls),e(U,fe),e(fe,As),e(fe,lt),e(lt,Ms),e(fe,Qs),e(fe,Ot),e(Ot,Vs),e(fe,Os),e(U,Ss),B(ze,U,null),m(o,Xn,f),m(o,me,f),e(me,Ie),e(Ie,St),B(vo,St,null),e(me,Ds),e(me,Dt),e(Dt,Ns),m(o,Yn,f),m(o,N,f),B(bo,N,null),e(N,Gs),e(N,Nt),e(Nt,Ws),e(N,Hs),e(N,J),B($o,J,null),e(J,Rs),e(J,T),e(T,Us),e(T,Gt),e(Gt,Js),e(T,Ks),e(T,Wt),e(Wt,Xs),e(T,Ys),e(T,Ht),e(Ht,Zs),e(T,ei),e(T,Rt),e(Rt,oi),e(T,ti),e(T,Ut),e(Ut,ni),e(T,ri),e(T,Jt),e(Jt,ai),e(T,si),e(T,Kt),e(Kt,ii),e(T,li),e(J,di),e(J,Bo),e(Bo,wo),e(wo,ci),e(wo,Xt),e(Xt,pi),e(wo,fi),e(Bo,mi),e(Bo,k),e(k,hi),e(k,Yt),e(Yt,gi),e(k,ui),e(k,Zt),e(Zt,_i),e(k,vi),e(k,en),e(en,bi),e(k,$i),e(k,on),e(on,Bi),e(k,wi),e(k,tn),e(tn,yi),e(k,Ci),e(k,nn),e(nn,ki),e(k,Pi),e(k,rn),e(rn,Ei),e(k,Ti),e(k,an),e(an,xi),e(k,Fi),e(k,sn),e(sn,zi),e(k,Ii),e(k,ln),e(ln,qi),e(k,ji),e(k,dn),e(dn,Li),e(k,Ai),e(k,cn),e(cn,Mi),e(k,Qi),e(k,pn),e(pn,Vi),e(k,Oi),e(k,fn),e(fn,Si),e(k,Di),m(o,Zn,f),m(o,he,f),e(he,qe),e(qe,mn),B(yo,mn,null),e(he,Ni),e(he,hn),e(hn,Gi),m(o,er,f),m(o,x,f),B(Co,x,null),e(x,Wi),e(x,gn),e(gn,Hi),e(x,Ri),e(x,ko),e(ko,Ui),e(ko,un),e(un,Ji),e(ko,Ki),e(x,Xi),e(x,Po),e(Po,Yi),e(Po,dt),e(dt,Zi),e(Po,el),e(x,ol),e(x,Eo),e(Eo,tl),e(Eo,To),e(To,nl),e(Eo,rl),e(x,al),e(x,z),B(xo,z,null),e(z,sl),e(z,ge),e(ge,il),e(ge,ct),e(ct,ll),e(ge,dl),e(ge,_n),e(_n,cl),e(ge,pl),e(z,fl),B(je,z,null),e(z,ml),e(z,vn),e(vn,hl),e(z,gl),B(Le,z,null),e(z,ul),B(Ae,z,null),e(x,_l),e(x,Me),B(Fo,Me,null),e(Me,vl),e(Me,zo),e(zo,bl),e(zo,bn),e(bn,$l),e(zo,Bl),or=!0},p(o,[f]){const Io={};f&2&&(Io.$$scope={dirty:f,ctx:o}),Be.$set(Io);const $n={};f&2&&($n.$$scope={dirty:f,ctx:o}),Ce.$set($n);const Bn={};f&2&&(Bn.$$scope={dirty:f,ctx:o}),Pe.$set(Bn);const wn={};f&2&&(wn.$$scope={dirty:f,ctx:o}),ze.$set(wn);const qo={};f&2&&(qo.$$scope={dirty:f,ctx:o}),je.$set(qo);const yn={};f&2&&(yn.$$scope={dirty:f,ctx:o}),Le.$set(yn);const Cn={};f&2&&(Cn.$$scope={dirty:f,ctx:o}),Ae.$set(Cn)},i(o){or||(w(d.$$.fragment,o),w(Oe.$$.fragment,o),w(Ue.$$.fragment,o),w(Xe.$$.fragment,o),w(Ye.$$.fragment,o),w(Be.$$.fragment,o),w(eo.$$.fragment,o),w(to.$$.fragment,o),w(no.$$.fragment,o),w(Ce.$$.fragment,o),w(ao.$$.fragment,o),w(so.$$.fragment,o),w(Pe.$$.fragment,o),w(lo.$$.fragment,o),w(co.$$.fragment,o),w(po.$$.fragment,o),w(mo.$$.fragment,o),w(go.$$.fragment,o),w(uo.$$.fragment,o),w(_o.$$.fragment,o),w(ze.$$.fragment,o),w(vo.$$.fragment,o),w(bo.$$.fragment,o),w($o.$$.fragment,o),w(yo.$$.fragment,o),w(Co.$$.fragment,o),w(xo.$$.fragment,o),w(je.$$.fragment,o),w(Le.$$.fragment,o),w(Ae.$$.fragment,o),w(Fo.$$.fragment,o),or=!0)},o(o){y(d.$$.fragment,o),y(Oe.$$.fragment,o),y(Ue.$$.fragment,o),y(Xe.$$.fragment,o),y(Ye.$$.fragment,o),y(Be.$$.fragment,o),y(eo.$$.fragment,o),y(to.$$.fragment,o),y(no.$$.fragment,o),y(Ce.$$.fragment,o),y(ao.$$.fragment,o),y(so.$$.fragment,o),y(Pe.$$.fragment,o),y(lo.$$.fragment,o),y(co.$$.fragment,o),y(po.$$.fragment,o),y(mo.$$.fragment,o),y(go.$$.fragment,o),y(uo.$$.fragment,o),y(_o.$$.fragment,o),y(ze.$$.fragment,o),y(vo.$$.fragment,o),y(bo.$$.fragment,o),y($o.$$.fragment,o),y(yo.$$.fragment,o),y(Co.$$.fragment,o),y(xo.$$.fragment,o),y(je.$$.fragment,o),y(Le.$$.fragment,o),y(Ae.$$.fragment,o),y(Fo.$$.fragment,o),or=!1},d(o){t(h),o&&t(P),o&&t(_),C(d),o&&t(Tn),o&&t(ee),C(Oe),o&&t(xn),o&&t(W),o&&t(Fn),o&&t(Lo),o&&t(zn),o&&t(Ao),o&&t(In),o&&t(Mo),o&&t(qn),o&&t(_e),o&&t(jn),o&&t(ve),o&&t(Ln),o&&t(We),o&&t(An),o&&t(H),o&&t(Mn),o&&t(oe),C(Ue),o&&t(Qn),o&&t(Oo),o&&t(Vn),o&&t(So),o&&t(On),o&&t(Do),o&&t(Sn),o&&t(te),C(Xe),o&&t(Dn),o&&t(q),C(Ye),C(Be),C(eo),o&&t(Nn),o&&t(re),C(to),o&&t(Gn),o&&t(Q),C(no),C(Ce),o&&t(Wn),o&&t(ie),C(ao),o&&t(Hn),o&&t(V),C(so),C(Pe),o&&t(Rn),o&&t(de),C(lo),o&&t(Un),o&&t(j),C(co),C(po),C(mo),o&&t(Jn),o&&t(ce),C(go),o&&t(Kn),o&&t(pe),C(uo),C(_o),C(ze),o&&t(Xn),o&&t(me),C(vo),o&&t(Yn),o&&t(N),C(bo),C($o),o&&t(Zn),o&&t(he),C(yo),o&&t(er),o&&t(x),C(Co),C(xo),C(je),C(Le),C(Ae),C(Fo)}}}const Tc={local:"blip2",sections:[{local:"overview",title:"Overview"},{local:"resources",title:"Resources"},{local:"transformers.Blip2Config",title:"Blip2Config"},{local:"transformers.Blip2VisionConfig",title:"Blip2VisionConfig"},{local:"transformers.Blip2QFormerConfig",title:"Blip2QFormerConfig"},{local:"transformers.Blip2Processor",title:"Blip2Processor"},{local:"transformers.Blip2VisionModel",title:"Blip2VisionModel"},{local:"transformers.Blip2QFormerModel",title:"Blip2QFormerModel"},{local:"transformers.Blip2ForConditionalGeneration",title:"Blip2ForConditionalGeneration"}],title:"BLIP-2"};function xc(F){return bc(()=>{new URLSearchParams(window.location.search).get("fw")}),[]}class Ac extends hc{constructor(h){super();gc(this,h,xc,Ec,uc,{})}}export{Ac as default,Tc as metadata};
